/* ##MKB
;-----------------------------------------------------------------------
; ##Copyright:          ABB
;-----------------------------------------------------------------------
; ##System           :  Transmitter
; ##Systemkomponente :  2000T
;-----------------------------------------------------------------------
; $Archive:: /Handheld/275/2000T/Sourcen/Rev 02/2000tmR2.ddl  $
; $Revision:: 1                                               $
;-----------------------------------------------------------------------
; ##Modulelemente    :
;
; - DDL of hand held terminal 275
;
; ##SPECEND
;-----------------------------------------------------------------------
; ##MKE*/


/**** IMPORT-Anweisung mit Liste der importierten Menues       */

IMPORT STANDARD _MENU, DEVICE_REVISION 1, DD_REVISION 1
{
    MENU root_menu ;
    MENU device_setup ;
    MENU process_variables ;
    MENU diag_service ;
    MENU test_device ;
    MENU status_display ;
    MENU basic_setup ;
    MENU detailed_setup ;
    MENU device_info ;
    MENU construction_materials ;
    MENU device_revisions ;
    MENU signal_conditioning ;
    MENU output_conditioning ;
    MENU hart_output;
    MENU analog_output ;
    MENU review ;
    MENU hot_key ;
    MENU calibration ;
    EDIT_DISPLAY rerange ;
    WRITE_AS_ONE range_wao ;

/**  Redefinition einiger Standardmens. **/

    REDEFINITIONS
    {
        REDEFINE WRITE_AS_ONE range_wao
        {
	        pressure_lower_range_value,		/* variable */
            pressure_upper_range_value		/* variable */
        }

        EDIT_DISPLAY rerange
        {
            REDEFINE EDIT_ITEMS {range_wao}

            REDEFINE DISPLAY_ITEMS {pressure_lower_range_limit, pressure_upper_range_limit}
        }

        MENU root_menu
        {
	        REDEFINE ITEMS
	        {
	            device_setup,                                       /* Menu */
	            PV.DIGITAL_VALUE (DISPLAY_VALUE, READ_ONLY),        /* Variable */
	            analog_output_value (DISPLAY_VALUE, READ_ONLY),     /* Variable */
	            PV.LOWER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY),    /* Variable */
	            PV.UPPER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY)     /* Variable */
	        }
        }


        MENU process_variables
        {
	        REDEFINE ITEMS
	        {
	            PV.DIGITAL_VALUE (DISPLAY_VALUE),                   /* Variable */
	            PV.PERCENT_RANGE (DISPLAY_VALUE),                   /* Variable */
	            analog_output_value (DISPLAY_VALUE, READ_ONLY),     /* Variable */
	            pressure.DIGITAL_VALUE (DISPLAY_VALUE),             /* Variable */
                stat_pressure.DIGITAL_VALUE (DISPLAY_VALUE),        /* Variable */
                process_temp.DIGITAL_VALUE (DISPLAY_VALUE),         /* Variable */
	            temperature.DIGITAL_VALUE (DISPLAY_VALUE)           /* Variable */
	        }
        }


        MENU diag_service
        {
	        REDEFINE ITEMS
	        {
		        test_device,        /* Menu */
		        loop_test,          /* Common-Method */
		        calibration         /* Menu */
	        }
        }


        MENU calibration
        {
   	        REDEFINE ITEMS
            {
	            applied_rerange     /* Method */
	        }
        }


        MENU test_device
        {
	        REDEFINE ITEMS
	        {
	            status_display (REVIEW),    /* Menu */
	            self_test,                  /* Common-Method */
	            master_reset                /* Common-Method */
	        }
        }


        MENU status_display
        {
	        REDEFINE ITEMS
	        {
	            diagnosis,                  /* Variable */
	            diagnosis1,
	            diagnosisExtension,         /* Variable */
	            diagnosisExtension1, diagnosisExtension2,
	            diagnosisExtension3
	        }
        }

        MENU basic_setup
        {
            REDEFINE ITEMS
            {
			    tag,						    /* variable */
				PV.DIGITAL_UNITS,				/* variable */
				PV.LOWER_RANGE_VALUE,           /* variable */
				PV.UPPER_RANGE_VALUE,           /* variable */
				device_info,					/* menu */
				PV.TRANSFER_FUNCTION, 			/* OPTIONAL */
                ptrbLowFlowCutOff,              /* variable */
                ptrbFlowLinSqrtPoint,           /* variable */
				PV.DAMPING_VALUE 				/* OPTIONAL */
            }
        }

        MENU detailed_setup
        {
	        REDEFINE ITEMS
	        {
	            menu_sensoren,                  /* Menu */
	            signal_conditioning,            /* Menu */
	            output_conditioning,            /* Menu */
	            device_info,                    /* Menu */
                reset_factory_data              /* Method */
	        }
        }


        MENU device_info
        {
	        REDEFINE ITEMS
	        {
	            private_label_distributor (DISPLAY_VALUE),      /* Variable */
	            pb_device_id (DISPLAY_VALUE),                   /* Variable */
	            device_id (DISPLAY_VALUE, READ_ONLY),           /* Variable */
	            tag (DISPLAY_VALUE),                            /* Variable */
	            date (DISPLAY_VALUE),                           /* Variable */
	            local_keys_mode_control_codes (DISPLAY_VALUE),  /* Variable */
	            write_protect (DISPLAY_VALUE),                  /* Variable */
	            pbWriteLock (DISPLAY_VALUE),                    /* Variable */
	            descriptor (DISPLAY_VALUE),                     /* Variable */
	            message (DISPLAY_VALUE),                        /* Variable */
	            final_assembly_number (DISPLAY_VALUE),          /* Variable */
	            pressure_sensor_serial_number (DISPLAY_VALUE, READ_ONLY), /* Variable */
	            meter_installation (DISPLAY_VALUE),             /* Variable */
	            construction_materials,                         /* Menu */
	            device_revisions                                /* Menu */
	        }
        }


        MENU construction_materials
        {
	        REDEFINE ITEMS
	        {
	            flange_type,                                    /* Variable */
	            flange_material,                                /* Variable */
	            o_ring_material,                                /* Variable */
	            drain_vent_material,                            /* Variable */
	            remote_seal_type,                               /* Variable */
	            remote_seal_fill_fluid,                         /* Variable */
	            remote_seal_isolator_material,                  /* Variable */
	            number_of_remote_seals (DISPLAY_VALUE, READ_ONLY),   /* Variable */
	            module_fill_fluid (DISPLAY_VALUE, READ_ONLY),   /* Variable */
	            module_isolator_material (DISPLAY_VALUE, READ_ONLY)  /* Variable */
	        }
        }


        MENU device_revisions
        {
	        REDEFINE ITEMS
	        {
	            universal_revision (DISPLAY_VALUE),
	            transmitter_revision (DISPLAY_VALUE),
	            software_revision (DISPLAY_VALUE),
	            hardware_revision (DISPLAY_VALUE, READ_ONLY)
	        }
        }


        MENU signal_conditioning
        {
	        REDEFINE ITEMS
	        {
	            PV.LOWER_RANGE_VALUE (DISPLAY_VALUE),           /* Variable */
	            PV.UPPER_RANGE_VALUE (DISPLAY_VALUE),           /* Variable */
	            pressure_output_transfer_function (DISPLAY_VALUE),  /* Variable */
                ptrbLowFlowCutOff (DISPLAY_VALUE),              /* variable */
                ptrbFlowLinSqrtPoint (DISPLAY_VALUE),           /* variable */
	            pressure_damping_value (DISPLAY_VALUE),         /* Variable */
	            pressure_percent_range (DISPLAY_VALUE)          /* Variable */
	        }
        }

        MENU output_conditioning
        {
	        REDEFINE ITEMS
	        {
	            analog_output,
	            hart_output
	        }
        }


        MENU analog_output
        {
    	    REDEFINE ITEMS
	        {
	            analog_output_alarm_select (DISPLAY_VALUE),
	            loop_test
	        }
        }


        MENU review
        {
	        REDEFINE ITEMS
	        {
	            pb_device_id (DISPLAY_VALUE, READ_ONLY),                        /* Variable */
	            private_label_distributor (DISPLAY_VALUE, READ_ONLY),           /* Variable */
	            PV.DIGITAL_UNITS (DISPLAY_VALUE, READ_ONLY),                    /* Variable */
	            PV.LOWER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY),                /* Variable */
	            PV.UPPER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY),                /* Variable */
	            pressure_output_transfer_function (DISPLAY_VALUE, READ_ONLY),   /* Variable */
	            ptrbLowFlowCutOff (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            ptrbFlowLinSqrtPoint (DISPLAY_VALUE, READ_ONLY),                /* Variable */
	            pressure_damping_value (DISPLAY_VALUE, READ_ONLY),              /* Variable */
	            pressure_units (DISPLAY_VALUE, READ_ONLY),                      /* Variable */
	            pressure_lower_range_value (DISPLAY_VALUE, READ_ONLY),          /* Variable */
	            pressure_upper_range_value (DISPLAY_VALUE, READ_ONLY),          /* Variable */
  	            pressure_lower_range_limit (DISPLAY_VALUE, READ_ONLY),          /* Variable */
  	            pressure_upper_range_limit (DISPLAY_VALUE, READ_ONLY),          /* Variable */
	            sensor_a_lower_sensor_trim_point (DISPLAY_VALUE, READ_ONLY),    /* Variable */
	            sensor_a_upper_sensor_trim_point (DISPLAY_VALUE, READ_ONLY),    /* Variable */
                    static_pressure_lo_lim (DISPLAY_VALUE, READ_ONLY),              /* Variable */
                    static_pressure_hi_lim (DISPLAY_VALUE, READ_ONLY),              /* Variable */
                    stat_press_sensor_lower_sensor_trim_point (DISPLAY_VALUE, READ_ONLY),  /* Variable */
	            stat_press_sensor_upper_sensor_trim_point (DISPLAY_VALUE, READ_ONLY),  /* Variable */
	            pressure_sensor_serial_number (DISPLAY_VALUE, READ_ONLY),       /* Variable */
	            module_range_code (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            pressure_minimum_span (DISPLAY_VALUE, READ_ONLY),               /* Variable */
	            meter_installation (DISPLAY_VALUE, READ_ONLY),                  /* Variable */
                    local_keys_mode_control_codes (DISPLAY_VALUE, READ_ONLY),       /* Variable */
	            analog_output_alarm_select (DISPLAY_VALUE, READ_ONLY),          /* Variable */
	            write_protect (DISPLAY_VALUE, READ_ONLY),                       /* Variable */
	            pbWriteLock (DISPLAY_VALUE, READ_ONLY),                         /* Variable */
	            manufacturer_id (DISPLAY_VALUE, READ_ONLY),                     /* Variable */
	            device_id (DISPLAY_VALUE, READ_ONLY),                           /* Variable */
	            tag (DISPLAY_VALUE, READ_ONLY),                                 /* Variable */
	            descriptor (DISPLAY_VALUE, READ_ONLY),                          /* Variable */
	            message (DISPLAY_VALUE, READ_ONLY),                             /* Variable */
	            date (DISPLAY_VALUE, READ_ONLY),                                /* Variable */
	            flange_type (DISPLAY_VALUE, READ_ONLY),                         /* Variable */
	            flange_material (DISPLAY_VALUE, READ_ONLY),                     /* Variable */
                    o_ring_material (DISPLAY_VALUE, READ_ONLY),                     /* Variable */
	            drain_vent_material (DISPLAY_VALUE, READ_ONLY),                 /* Variable */
	            remote_seal_type (DISPLAY_VALUE, READ_ONLY),                    /* Variable */
	            remote_seal_fill_fluid (DISPLAY_VALUE, READ_ONLY),              /* Variable */
	            remote_seal_isolator_material (DISPLAY_VALUE, READ_ONLY),       /* Variable */
	            number_of_remote_seals (DISPLAY_VALUE, READ_ONLY),              /* Variable */
	            module_fill_fluid (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            module_isolator_material (DISPLAY_VALUE, READ_ONLY),            /* Variable */
	            rated_pressure (DISPLAY_VALUE, READ_ONLY),                      /* Variable */
	            universal_revision (DISPLAY_VALUE, READ_ONLY),                  /* Variable */
	            transmitter_revision (DISPLAY_VALUE, READ_ONLY),                /* Variable */
                    software_revision (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            hardware_revision (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            burst_mode_select (DISPLAY_VALUE, READ_ONLY),                   /* Variable */
	            polling_address (DISPLAY_VALUE, READ_ONLY),                     /* Variable */
	            request_preambles (DISPLAY_VALUE, READ_ONLY)                    /* Variable */
	        }
        }
    }
}



/*
**** Definition neuer Menues. ****
*/


MENU upload_variables
{
	LABEL "|001Write variables"
		  "|049Variablen speichern";
	ITEMS
	{
	   	tag,                                /* variable */
		date,                               /* variable */
		descriptor,                         /* variable */
		message,                            /* variable */
		PV.DIGITAL_UNITS,                   /* variable */
		PV.LOWER_RANGE_VALUE,               /* Variable */
		PV.UPPER_RANGE_VALUE,               /* Variable */
		pressure_output_transfer_function,  /* variable */
		ptrbLowFlowCutOff,                  /* Variable */
		ptrbFlowLinSqrtPoint,               /* Variable */
		pressure_damping_value,             /* variable */
		pressure_units,                     /* Variable */
		pressure_lower_range_value,         /* Variable */
		pressure_upper_range_value,         /* Variable */
		meter_installation,                 /* variable */
		analog_output_alarm_select,         /* Variable */
		static_pressure_units,              /* Variable */
	        polling_address 		            /* Variable	*/
	}
}

MENU menu_sensoren
{
	LABEL "|001Sensors"
          "|049Sensoren";
	ITEMS
	{
	menu_drucksensor,                       /* Menu */
	menu_temperatursensor                   /* Menu */
	}
}


MENU menu_drucksensor
{
	LABEL "|001Pressure Sensor"
          "|049Drucksensor";
	ITEMS
	{
	    pressure.DIGITAL_VALUE (DISPLAY_VALUE), /* Variable */
	    pressure.DIGITAL_UNITS (DISPLAY_VALUE), /* Variable */
	    rerange,                                /* Edit Display */
	    zero_trim,                              /* Common Method */
            full_trim,                              /* Menu */
            stat_pressure.DIGITAL_UNITS (DISPLAY_VALUE), /* Variable */
            stat_press_trim,                        /* Menu */
	    menu_drucksensor_info                   /* Menu */
	}
}


MENU full_trim
{
	LABEL "|001Full trim"
          "|049Bereichskalibrierung";
	ITEMS
	{
		sensor_a_lower_sensor_trim,             /* Method */
		sensor_a_upper_sensor_trim              /* Method */
	}
}


MENU stat_press_trim
{
	LABEL "|001Stat pres trim"
          "|049Kal. stat. Druck";
	ITEMS
	{
		stat_press_lower_sensor_trim,           /* Method */
		stat_press_upper_sensor_trim            /* Method */
	}
}


MENU menu_drucksensor_info
{
	LABEL "|001Pres sens info"
          "|049Drucksensor-Info";
	ITEMS
	{
		pb_device_id (DISPLAY_VALUE, READ_ONLY),                /* Variable */
		pressure_lower_range_limit (DISPLAY_VALUE, READ_ONLY),  /* Variable */
		pressure_upper_range_limit (DISPLAY_VALUE, READ_ONLY),  /* Variable */
		pressure_minimum_span (DISPLAY_VALUE, READ_ONLY)        /* Variable */
	}
}


MENU menu_temperatursensor
{
	LABEL "|001Sens temp sensor"
          "|049Temperaturmessung";
	ITEMS
	{
		temperature.DIGITAL_VALUE (DISPLAY_VALUE),     /* Variable */
		temperature.DIGITAL_UNITS (DISPLAY_VALUE)      /* Variable */
	}
}


/*************      Versionsnummer     *****************/

VARIABLE  v_version
{
    LABEL  "Version 1.00";
    CLASS  LOCAL;
    HANDLING READ;
    TYPE   ENUMERATED
    {
        {0, "|001English"
	        "|049Deutsch",
	        "|001Language of strings"
            "|049Landessprache der Texte"}
    }
}
/*******************************************************/
