/* ##MKB
;-----------------------------------------------------------------------
; ##Copyright:          ABB
;-----------------------------------------------------------------------
; ##System           :  Transmitter
; ##Systemkomponente :  2000T
;-----------------------------------------------------------------------
; $Archive:: /Handheld/275/2000T/Sourcen/Rev 02/2000TR2.ddl   $
; $Revision:: 1                                               $
;-----------------------------------------------------------------------
; ##Modulelemente    :
;
; - DDL of hand held terminal 275
;
; ##SPECEND
;-----------------------------------------------------------------------
; ##MKE*/



/******************************************************************************/
/*  Definition: Variablen fr SV, TV
                      ARRAY OF COLLECTION  dynamic_variables
                      Variablen fr private Kommandos
                      private Kommandos
                      neue Methoden    */
/******************************************************************************/


MANUFACTURER ABB, DEVICE_TYPE _2000T, DEVICE_REVISION 2, DD_REVISION 2

/* Standard-Include-Dateien laden */
#include "bi_codes.h"
#include "macros.ddl"


/* importierte Standard-DDL's und deren Redefinitionen laden */
#include "2000TiR2.ddl"


/* Menu-DDL laden */
#include "2000TmR2.ddl"



/**************** neue DD-definitionen **********************/

VARIABLE free_process_variable
{
    LABEL
        IF (software_revision < 21)
        {
            [pressure_value];
        }
        ELSE
        {
            "|001Process value"
            "|049Prozesswert";
        }
    HELP    [digital_value_help];
    HANDLING READ;
    CLASS  CORRECTION & DYNAMIC;
    TYPE FLOAT
    {
/*        DISPLAY_FORMAT ".3g";
*/
        DISPLAY_FORMAT ".3f";
    }
}


VARIABLE  free_proc_var_stat_press
{
    LABEL
        IF (software_revision < 21)
        {
            "|001Process value"
            "|049Prozesswert";
        }
        ELSE
        {
            "|001Stat pres"
            "|049St Druck";
        }
    HELP    [digital_value_help];
    HANDLING READ;
    CLASS  CORRECTION & DYNAMIC;
    TYPE FLOAT
    {
        DISPLAY_FORMAT
            IF (software_revision < 21)
            {
                ".3f";
/*                ".3g";
*/
            }
            ELSE
            {
                ".1f";
            }
    }
    VALIDITY
        /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF ((software_revision > 20) && (module_type_code >= 30))    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}


VARIABLE free_process_variable_units
{
    LABEL
        IF (software_revision < 21)
        {
            [units];
        }
        ELSE
        {
            "|001Process value unit"
            "|049Dim.Prozesswert";
        }
    HELP
        IF (software_revision < 21)
        {
            [digital_units_help];
        }
        ELSE
        {
            "|001Process value unit-"       /*ndern!!!!!*/
            "|049Dim. Prozesswert-";
        }
    TYPE ENUMERATED
    {
        IF (software_revision < 21)
        {
            {    1,  "|001inH2O"
                     "|049inH2O"},
            {    2,  "|001inHg"
                     "|049inHg"},
            {    3,  "|001ftH2O"
                     "|049ftH2O"},
            {    4,  "|001mmH2O"
                     "|049mmH2O"},
            {    5,  "|001mmHg"
                     "|049mmHg"},
            {    6,  "|001psi"
                     "|049psi"},
            {    7,  "|001bar"
                     "|049bar"},
            {    8,  "|001mbar"
                     "|049mbar"},
            {    9,  "|001g/cm2"
                     "|049g/cm2"},
            {   10,  "|001kg/cm2"
                     "|049kg/cm2"},
            {   11,  "|001Pa"
                     "|049Pa"},
            {   12,  "|001kPa"
                     "|049kPa"},
            {   13,  "|001torr"
                     "|049torr"},
            {   14,  "|001atm"
                     "|049atm"},
            {  237,  "|001MPa"
                     "|049MPa"},
            {  253,  "|001special"
                     "|049Spezial"}
        }
        ELSE
        {
            {    1,  "|001inH2O"
                     "|049inH2O"},
            {    2,  "|001inHg"
                     "|049inHg"},
            {    3,  "|001ftH2O"
                     "|049ftH2O"},
            {    4,  "|001mmH2O"
                     "|049mmH2O"},
            {    5,  "|001mmHg"
                     "|049mmHg"},
            {    6,  "|001psi"
                     "|049psi"},
            {    7,  "|001bar"
                     "|049bar"},
            {    8,  "|001mbar"
                     "|049mbar"},
            {    9,  "|001g/cm2"
                     "|049g/cm2"},
            {   10,  "|001kg/cm2"
                     "|049kg/cm2"},
            {   11,  "|001Pa"
                     "|049Pa"},
            {   12,  "|001kPa"
                     "|049kPa"},
            {   13,  "|001torr"
                     "|049torr"},
            {   14,  "|001atm"
                     "|049atm"},
            {   15,  "|001CFM"
                     "|049CFM"},
            {   16,  "|001GPM"
                     "|049GPM"},
            {   17,  "|001L/min"
                     "|049L/min"},
            {   18,  "|001ImpGal/min"
                     "|049ImpGal/min"},
            {   19,  "|001m3/h"
                     "|049m3/h"},
            {   20,  "|001ft/s"
                     "|049ft/s"},
            {   21,  "|001m/s"
                     "|049m/s"},
            {   22,  "|001gal/s"
                     "|049gal/s"},
            {   23,  "|001Mgal/d"
                     "|049Mgal/d"},
            {   24,  "|001L/s"
                     "|049L/s"},
            {   25,  "|001ML/d"
                     "|049ML/d"},
            {   26,  "|001CFS"
                     "|049CFS"},
            {   27,  "|001ft3/d"
                     "|049ft3/d"},
            {   28,  "|001m3/s"
                     "|049m3/s"},
            {   29,  "|001m3/d"
                     "|049m3/d"},
            {   30,  "|001ImpGal/h"
                     "|049ImpGal/h"},
            {   31,  "|001ImpGal/d"
                     "|049ImpGal/d"},
            {   32,  "|001C"
                     "|049C"},
            {   33,  "|001F"
                     "|049F"},
            {   34,  "|001R"
                     "|049R"},
            {   35,  "|001K"
                     "|049K"},
            {   36,  "|001mV"
                     "|049mV"},
            {   37,  "|001Ohm"
                     "|049Ohm"},
            {   38,  "|001Hz"
                     "|049Hz"},
            {   39,  "|001mA"
                     "|049mA"},
            {   40,  "|001gallon"
                     "|049gallon"},
            {   41,  "|001L"
                     "|049L"},
            {   42,  "|001ImpGal"
                     "|049ImpGal"},
            {   43,  "|001m3"
                     "|049m3"},
            {   44,  "|001ft"
                     "|049ft"},
            {   45,  "|001m"
                     "|049m"},
            {   46,  "|001bbl"
                     "|049bbl"},
            {   47,  "|001in"
                     "|049in"},
            {   48,  "|001cm"
                     "|049cm"},
            {   49,  "|001mm"
                     "|049mm"},
            {   50,  "|001min"
                     "|049min"},
            {   51,  "|001s"
                     "|049s"},
            {   52,  "|001h"
                     "|049h"},
            {   53,  "|001d"
                     "|049d"},
            {   54,  "|001cSt"
                     "|049cSt"},
            {   55,  "|001cP"
                     "|049cP"},
            {   56,  "|001uS"
                     "|049uS"},
            {   57,  "|001%"
                     "|049%"},
            {   58,  "|001V"
                     "|049V"},
            {   59,  "|001pH"
                     "|049pH"},
            {   60,  "|001g"
                     "|049g"},
            {   61,  "|001kg"
                     "|049kg"},
            {   62,  "|001t"
                     "|049t"},
            {   63,  "|001lb"
                     "|049lb"},
            {   64,  "|001STon"
                     "|049STon"},
            {   65,  "|001LTon"
                     "|049LTon"},
            {   66,  "|001mS/cm"
                     "|049mS/cm"},
            {   67,  "|001uS/mm"
                     "|049uS/mm"},
            {   70,  "|001g/s"
                     "|049g/s"},
            {   71,  "|001g/min"
                     "|049g/min"},
            {   72,  "|001g/h"
                     "|049g/h"},
            {   73,  "|001kg/s"
                     "|049kg/s"},
            {   74,  "|001kg/min"
                     "|049kg/min"},
            {   75,  "|001kg/h"
                     "|049kg/h"},
            {   76,  "|001kg/d"
                     "|049kg/d"},
            {   77,  "|001t/min"
                     "|049t/min"},
            {   78,  "|001t/h"
                     "|049t/h"},
            {   79,  "|001t/d"
                     "|049t/d"},
            {   80,  "|001lb/s"
                     "|049lb/s"},
            {   81,  "|001lb/min"
                     "|049lb/min"},
            {   82,  "|001lb/h"
                     "|049lb/h"},
            {   83,  "|001lb/d"
                     "|049lb/d"},
            {   84,  "|001STon/min"
                     "|049STon/min"},
            {   85,  "|001STon/h"
                     "|049STon/h"},
            {   86,  "|001STon/d"
                     "|049STon/d"},
            {   87,  "|001LTon/h"
                     "|049LTon/h"},
            {   88,  "|001LTon/d"
                     "|049LTon/d"},
            {   89,  "|001decatherm"
                     "|049decatherm"},
            {   90,  "|001SGU"
                     "|049SGU"},
            {   91,  "|001g/cm3"
                     "|049g/cm3"},
            {   92,  "|001kg/m3"
                     "|049kg/m3"},
            {   93,  "|001lb/gal"
                     "|049lb/gal"},
            {   94,  "|001lb/ft3"
                     "|049lb/ft3"},
            {   95,  "|001g/ml"
                     "|049g/ml"},
            {   96,  "|001kg/L"
                     "|049kg/L"},
            {   97,  "|001g/L"
                     "|049g/L"},
            {   98,  "|001lb/in3"
                     "|049lb/in3"},
            {   99,  "|001STon/yd3"
                     "|049STon/yd3"},
            {  100,  "|001degTwad"
                     "|049degTwad"},
            {  101,  "|001degBrix"
                     "|049degBrix"},
            {  102,  "|001degBaum hv"
                     "|049degBaum hv"},
            {  103,  "|001degBaum lt"
                     "|049degBaum lt"},
            {  104,  "|001degAPI"
                     "|049degAPI"},
            {  105,  "|001% sol/wt"
                     "|049% sol/wt"},
            {  106,  "|001% sol/vol"
                     "|049% sol/vol"},
            {  107,  "|001degBall"
                     "|049degBall"},
            {  108,  "|001proof/vol"
                     "|049proof/vol"},
            {  109,  "|001proof/mass"
                     "|049proof/mass"},
            {  110,  "|001bushel"
                     "|049bushel"},
            {  111,  "|001yd3"
                     "|049yd3"},
            {  112,  "|001ft3"
                     "|049ft3"},
            {  113,  "|001in3"
                     "|049in3"},
            {  120,  "|001m/h"
                     "|049m/h"},
            {  121,  "|001Nm3/h"
                     "|049Nm3/h"},
            {  122,  "|001NL/h"
                     "|049NL/h"},
            {  123,  "|001SCFM"
                     "|049SCFM"},
            {  124,  "|001bbl (liq)"
                     "|049bbl (liq)"},
            {  125,  "|001oz"
                     "|049oz"},
            {  126,  "|001ft-lb"
                     "|049ft-lb"},
            {  127,  "|001KW"
                     "|049KW"},
            {  128,  "|001KWH"
                     "|049KWH"},
            {  129,  "|001hp"
                     "|049hp"},
            {  130,  "|001CFH"
                     "|049CFH"},
            {  131,  "|001m3/min"
                     "|049m3/min"},
            {  132,  "|001bbl/s"
                     "|049bbl/s"},
            {  133,  "|001bbl/min"
                     "|049bbl/min"},
            {  134,  "|001bbl/h"
                     "|049bbl/h"},
            {  135,  "|001bbl/d"
                     "|049bbl/d"},
            {  136,  "|001gal/h"
                     "|049gal/h"},
            {  137,  "|001ImpGal/s"
                     "|049ImpGal/s"},
            {  138,  "|001L/h"
                     "|049L/h"},
            {  139,  "|001ppm"
                     "|049ppm"},
            {  140,  "|001Mcal/h"
                     "|049Mcal/h"},
            {  141,  "|001MJ/h"
                     "|049MJ/h"},
            {  142,  "|001Btu/h"
                     "|049Btu/h"},
            {  150,  "|001% stm qual"
                     "|049% stm qual"},
            {  152,  "|001ft3/lb"
                     "|049ft3/lb"},
            {  153,  "|001pF"
                     "|049pF"},
            {  160,  "|001% plato"
                     "|049% plato"},
            {  162,  "|001Mcal"
                     "|049Mcal"},
            {  163,  "|001kOhm"
                     "|049kOhm"},
            {  164,  "|001MJ"
                     "|049MJ"},
            {  165,  "|001Btu"
                     "|049Btu"},
            {  166,  "|001Nm3"
                     "|049Nm3"},
            {  167,  "|001NL"
                     "|049NL"},
            {  168,  "|001Sft3"
                     "|049Sft3"},
            {  235,  "|001gal/d"
                     "|049gal/d"},
            {  236,  "|001hl"
                     "|049hl"},
            {  237,  "|001MPa"
                     "|049MPa"},
            {  238,  "|001inH2O (4C)"
                     "|049inH2O (4C)"},
            {  239,  "|001mmH2O (4C)"
                     "|049mmH2O (4C)"},
            {  240,  "|001W"
                     "|049W"},
            {  241,  "|001MW"
                     "|049MW"},
            {  242,  "|001Mft3/d"
                     "|049Mft3/d"},
            {  245,  "|001WH"
                     "|049WH"},
            {  246,  "|001MWH"
                     "|049MWH"},
            {  247,  "|001J"
                     "|049J"},
            {  248,  "|001kJ"
                     "|049kJ"},
            {  249,  "|001kJ/kg"
                     "|049kJ/kg"},
            {  253,  "|001special"
                     "|049Spezial"}
        }
    }
    HANDLING READ & WRITE;
}


VARIABLE free_process_var_units
{
    LABEL "|001Process value unit"
          "|049Proz.wert Dimens.";
    HELP "|001Process value Unit- unit in which digital value,"
         " upper range value and lower range value are displayed. "
         "|049Prozesswert Dimension- Dimension mit der der digitale Wert, die"
         " obere Mebereichsgrenze und die untere Mebereichsgrenze behaftet sind.";
    TYPE ENUMERATED
    {
        {    1,  "|001inH2O"
                 "|049inH2O"},
        {    2,  "|001inHg"
                 "|049inHg"},
        {    3,  "|001ftH2O"
                 "|049ftH2O"},
        {    4,  "|001mmH2O"
                 "|049mmH2O"},
        {    5,  "|001mmHg"
                 "|049mmHg"},
        {    6,  "|001psi"
                 "|049psi"},
        {    7,  "|001bar"
                 "|049bar"},
        {    8,  "|001mbar"
                 "|049mbar"},
        {    9,  "|001g/cm2"
                 "|049g/cm2"},
        {   10,  "|001kg/cm2"
                 "|049kg/cm2"},
        {   11,  "|001Pa"
                 "|049Pa"},
        {   12,  "|001kPa"
                 "|049kPa"},
        {   13,  "|001torr"
                 "|049torr"},
        {   14,  "|001atm"
                 "|049atm"},
        {   15,  "|001CFM"
                 "|049CFM"},
        {   16,  "|001GPM"
                 "|049GPM"},
        {   17,  "|001L/min"
                 "|049L/min"},
        {   18,  "|001ImpGal/min"
                 "|049ImpGal/min"},
        {   19,  "|001m3/h"
                 "|049m3/h"},
        {   20,  "|001ft/s"
                 "|049ft/s"},
        {   21,  "|001m/s"
                 "|049m/s"},
        {   22,  "|001gal/s"
                 "|049gal/s"},
        {   23,  "|001Mgal/d"
                 "|049Mgal/d"},
        {   24,  "|001L/s"
                 "|049L/s"},
        {   25,  "|001ML/d"
                 "|049ML/d"},
        {   26,  "|001CFS"
                 "|049CFS"},
        {   27,  "|001ft3/d"
                 "|049ft3/d"},
        {   28,  "|001m3/s"
                 "|049m3/s"},
        {   29,  "|001m3/d"
                 "|049m3/d"},
        {   30,  "|001ImpGal/h"
                 "|049ImpGal/h"},
        {   31,  "|001ImpGal/d"
                 "|049ImpGal/d"},
        {   32,  "|001C"
                 "|049C"},
        {   33,  "|001F"
                 "|049F"},
        {   34,  "|001R"
                 "|049R"},
        {   35,  "|001K"
                 "|049K"},
        {   36,  "|001mV"
                 "|049mV"},
        {   37,  "|001Ohm"
                 "|049Ohm"},
        {   38,  "|001Hz"
                 "|049Hz"},
        {   39,  "|001mA"
                 "|049mA"},
        {   40,  "|001gallon"
                 "|049gallon"},
        {   41,  "|001L"
                 "|049L"},
        {   42,  "|001ImpGal"
                 "|049ImpGal"},
        {   43,  "|001m3"
                 "|049m3"},
        {   44,  "|001ft"
                 "|049ft"},
        {   45,  "|001m"
                 "|049m"},
        {   46,  "|001bbl"
                 "|049bbl"},
        {   47,  "|001in"
                 "|049in"},
        {   48,  "|001cm"
                 "|049cm"},
        {   49,  "|001mm"
                 "|049mm"},
        {   50,  "|001min"
                 "|049min"},
        {   51,  "|001s"
                 "|049s"},
        {   52,  "|001h"
                 "|049h"},
        {   53,  "|001d"
                 "|049d"},
        {   54,  "|001cSt"
                 "|049cSt"},
        {   55,  "|001cP"
                 "|049cP"},
        {   56,  "|001uS"
                 "|049uS"},
        {   57,  "|001%"
                 "|049%"},
        {   58,  "|001V"
                 "|049V"},
        {   59,  "|001pH"
                 "|049pH"},
        {   60,  "|001g"
                 "|049g"},
        {   61,  "|001kg"
                 "|049kg"},
        {   62,  "|001t"
                 "|049t"},
        {   63,  "|001lb"
                 "|049lb"},
        {   64,  "|001STon"
                 "|049STon"},
        {   65,  "|001LTon"
                 "|049LTon"},
        {   66,  "|001mS/cm"
                 "|049mS/cm"},
        {   67,  "|001uS/mm"
                 "|049uS/mm"},
        {   70,  "|001g/s"
                 "|049g/s"},
        {   71,  "|001g/min"
                 "|049g/min"},
        {   72,  "|001g/h"
                 "|049g/h"},
        {   73,  "|001kg/s"
                 "|049kg/s"},
        {   74,  "|001kg/min"
                 "|049kg/min"},
        {   75,  "|001kg/h"
                 "|049kg/h"},
        {   76,  "|001kg/d"
                 "|049kg/d"},
        {   77,  "|001t/min"
                 "|049t/min"},
        {   78,  "|001t/h"
                 "|049t/h"},
        {   79,  "|001t/d"
                 "|049t/d"},
        {   80,  "|001lb/s"
                 "|049lb/s"},
        {   81,  "|001lb/min"
                 "|049lb/min"},
        {   82,  "|001lb/h"
                 "|049lb/h"},
        {   83,  "|001lb/d"
                 "|049lb/d"},
        {   84,  "|001STon/min"
                 "|049STon/min"},
        {   85,  "|001STon/h"
                 "|049STon/h"},
        {   86,  "|001STon/d"
                 "|049STon/d"},
        {   87,  "|001LTon/h"
                 "|049LTon/h"},
        {   88,  "|001LTon/d"
                 "|049LTon/d"},
        {   89,  "|001decatherm"
                 "|049decatherm"},
        {   90,  "|001SGU"
                 "|049SGU"},
        {   91,  "|001g/cm3"
                 "|049g/cm3"},
        {   92,  "|001kg/m3"
                 "|049kg/m3"},
        {   93,  "|001lb/gal"
                 "|049lb/gal"},
        {   94,  "|001lb/ft3"
                 "|049lb/ft3"},
        {   95,  "|001g/ml"
                 "|049g/ml"},
        {   96,  "|001kg/L"
                 "|049kg/L"},
        {   97,  "|001g/L"
                 "|049g/L"},
        {   98,  "|001lb/in3"
                 "|049lb/in3"},
        {   99,  "|001STon/yd3"
                 "|049STon/yd3"},
        {  100,  "|001degTwad"
                 "|049degTwad"},
        {  101,  "|001degBrix"
                 "|049degBrix"},
        {  102,  "|001degBaum hv"
                 "|049degBaum hv"},
        {  103,  "|001degBaum lt"
                 "|049degBaum lt"},
        {  104,  "|001degAPI"
                 "|049degAPI"},
        {  105,  "|001% sol/wt"
                 "|049% sol/wt"},
        {  106,  "|001% sol/vol"
                 "|049% sol/vol"},
        {  107,  "|001degBall"
                 "|049degBall"},
        {  108,  "|001proof/vol"
                 "|049proof/vol"},
        {  109,  "|001proof/mass"
                 "|049proof/mass"},
        {  110,  "|001bushel"
                 "|049bushel"},
        {  111,  "|001yd3"
                 "|049yd3"},
        {  112,  "|001ft3"
                 "|049ft3"},
        {  113,  "|001in3"
                 "|049in3"},
        {  120,  "|001m/h"
                 "|049m/h"},
        {  121,  "|001Nm3/h"
                 "|049Nm3/h"},
        {  122,  "|001NL/h"
                 "|049NL/h"},
        {  123,  "|001SCFM"
                 "|049SCFM"},
        {  124,  "|001bbl (liq)"
                 "|049bbl (liq)"},
        {  125,  "|001oz"
                 "|049oz"},
        {  126,  "|001ft-lb"
                 "|049ft-lb"},
        {  127,  "|001KW"
                 "|049KW"},
        {  128,  "|001KWH"
                 "|049KWH"},
        {  129,  "|001hp"
                 "|049hp"},
        {  130,  "|001CFH"
                 "|049CFH"},
        {  131,  "|001m3/min"
                 "|049m3/min"},
        {  132,  "|001bbl/s"
                 "|049bbl/s"},
        {  133,  "|001bbl/min"
                 "|049bbl/min"},
        {  134,  "|001bbl/h"
                 "|049bbl/h"},
        {  135,  "|001bbl/d"
                 "|049bbl/d"},
        {  136,  "|001gal/h"
                 "|049gal/h"},
        {  137,  "|001ImpGal/s"
                 "|049ImpGal/s"},
        {  138,  "|001L/h"
                 "|049L/h"},
        {  139,  "|001ppm"
                 "|049ppm"},
        {  140,  "|001Mcal/h"
                 "|049Mcal/h"},
        {  141,  "|001MJ/h"
                 "|049MJ/h"},
        {  142,  "|001Btu/h"
                 "|049Btu/h"},
        {  150,  "|001% stm qual"
                 "|049% stm qual"},
        {  152,  "|001ft3/lb"
                 "|049ft3/lb"},
        {  153,  "|001pF"
                 "|049pF"},
        {  160,  "|001% plato"
                 "|049% plato"},
        {  162,  "|001Mcal"
                 "|049Mcal"},
        {  163,  "|001kOhm"
                 "|049kOhm"},
        {  164,  "|001MJ"
                 "|049MJ"},
        {  165,  "|001Btu"
                 "|049Btu"},
        {  166,  "|001Nm3"
                 "|049Nm3"},
        {  167,  "|001NL"
                 "|049NL"},
        {  168,  "|001Sft3"
                 "|049Sft3"},
        {  235,  "|001gal/d"
                 "|049gal/d"},
        {  236,  "|001hl"
                 "|049hl"},
        {  237,  "|001MPa"
                 "|049MPa"},
        {  238,  "|001inH2O (4C)"
                 "|049inH2O (4C)"},
        {  239,  "|001mmH2O (4C)"
                 "|049mmH2O (4C)"},
        {  240,  "|001W"
                 "|049W"},
        {  241,  "|001MW"
                 "|049MW"},
        {  242,  "|001Mft3/d"
                 "|049Mft3/d"},
        {  245,  "|001WH"
                 "|049WH"},
        {  246,  "|001MWH"
                 "|049MWH"},
        {  247,  "|001J"
                 "|049J"},
        {  248,  "|001kJ"
                 "|049kJ"},
        {  249,  "|001kJ/kg"
                 "|049kJ/kg"},
        {  253,  "|001special"
                 "|049Spezial"}
    }
    HANDLING READ;
}


VARIABLE aidp_outscale_units
{
    LABEL "|001Process value unit"
          "|049Proz.wert Dimens.";
    HELP "|001Process value Unit- unit in which digital value,"
         " upper range value and lower range value are displayed. "
         "|049Prozesswert Dimension- Dimension mit der der digitale Wert, die"
         " obere Mebereichsgrenze und die untere Mebereichsgrenze behaftet sind.";
    TYPE ENUMERATED
    {
        {    1,  "|001inH2O"
                 "|049inH2O"},
        {    2,  "|001inHg"
                 "|049inHg"},
        {    3,  "|001ftH2O"
                 "|049ftH2O"},
        {    4,  "|001mmH2O"
                 "|049mmH2O"},
        {    5,  "|001mmHg"
                 "|049mmHg"},
        {    6,  "|001psi"
                 "|049psi"},
        {    7,  "|001bar"
                 "|049bar"},
        {    8,  "|001mbar"
                 "|049mbar"},
        {    9,  "|001g/cm2"
                 "|049g/cm2"},
        {   10,  "|001kg/cm2"
                 "|049kg/cm2"},
        {   11,  "|001Pa"
                 "|049Pa"},
        {   12,  "|001kPa"
                 "|049kPa"},
        {   13,  "|001torr"
                 "|049torr"},
        {   14,  "|001atm"
                 "|049atm"},
        {   15,  "|001CFM"
                 "|049CFM"},
        {   16,  "|001GPM"
                 "|049GPM"},
        {   17,  "|001L/min"
                 "|049L/min"},
        {   18,  "|001ImpGal/min"
                 "|049ImpGal/min"},
        {   19,  "|001m3/h"
                 "|049m3/h"},
        {   20,  "|001ft/s"
                 "|049ft/s"},
        {   21,  "|001m/s"
                 "|049m/s"},
        {   22,  "|001gal/s"
                 "|049gal/s"},
        {   23,  "|001Mgal/d"
                 "|049Mgal/d"},
        {   24,  "|001L/s"
                 "|049L/s"},
        {   25,  "|001ML/d"
                 "|049ML/d"},
        {   26,  "|001CFS"
                 "|049CFS"},
        {   27,  "|001ft3/d"
                 "|049ft3/d"},
        {   28,  "|001m3/s"
                 "|049m3/s"},
        {   29,  "|001m3/d"
                 "|049m3/d"},
        {   30,  "|001ImpGal/h"
                 "|049ImpGal/h"},
        {   31,  "|001ImpGal/d"
                 "|049ImpGal/d"},
        {   32,  "|001C"
                 "|049C"},
        {   33,  "|001F"
                 "|049F"},
        {   34,  "|001R"
                 "|049R"},
        {   35,  "|001K"
                 "|049K"},
        {   36,  "|001mV"
                 "|049mV"},
        {   37,  "|001Ohm"
                 "|049Ohm"},
        {   38,  "|001Hz"
                 "|049Hz"},
        {   39,  "|001mA"
                 "|049mA"},
        {   40,  "|001gallon"
                 "|049gallon"},
        {   41,  "|001L"
                 "|049L"},
        {   42,  "|001ImpGal"
                 "|049ImpGal"},
        {   43,  "|001m3"
                 "|049m3"},
        {   44,  "|001ft"
                 "|049ft"},
        {   45,  "|001m"
                 "|049m"},
        {   46,  "|001bbl"
                 "|049bbl"},
        {   47,  "|001in"
                 "|049in"},
        {   48,  "|001cm"
                 "|049cm"},
        {   49,  "|001mm"
                 "|049mm"},
        {   50,  "|001min"
                 "|049min"},
        {   51,  "|001s"
                 "|049s"},
        {   52,  "|001h"
                 "|049h"},
        {   53,  "|001d"
                 "|049d"},
        {   54,  "|001cSt"
                 "|049cSt"},
        {   55,  "|001cP"
                 "|049cP"},
        {   56,  "|001uS"
                 "|049uS"},
        {   57,  "|001%"
                 "|049%"},
        {   58,  "|001V"
                 "|049V"},
        {   59,  "|001pH"
                 "|049pH"},
        {   60,  "|001g"
                 "|049g"},
        {   61,  "|001kg"
                 "|049kg"},
        {   62,  "|001t"
                 "|049t"},
        {   63,  "|001lb"
                 "|049lb"},
        {   64,  "|001STon"
                 "|049STon"},
        {   65,  "|001LTon"
                 "|049LTon"},
        {   66,  "|001mS/cm"
                 "|049mS/cm"},
        {   67,  "|001uS/mm"
                 "|049uS/mm"},
        {   70,  "|001g/s"
                 "|049g/s"},
        {   71,  "|001g/min"
                 "|049g/min"},
        {   72,  "|001g/h"
                 "|049g/h"},
        {   73,  "|001kg/s"
                 "|049kg/s"},
        {   74,  "|001kg/min"
                 "|049kg/min"},
        {   75,  "|001kg/h"
                 "|049kg/h"},
        {   76,  "|001kg/d"
                 "|049kg/d"},
        {   77,  "|001t/min"
                 "|049t/min"},
        {   78,  "|001t/h"
                 "|049t/h"},
        {   79,  "|001t/d"
                 "|049t/d"},
        {   80,  "|001lb/s"
                 "|049lb/s"},
        {   81,  "|001lb/min"
                 "|049lb/min"},
        {   82,  "|001lb/h"
                 "|049lb/h"},
        {   83,  "|001lb/d"
                 "|049lb/d"},
        {   84,  "|001STon/min"
                 "|049STon/min"},
        {   85,  "|001STon/h"
                 "|049STon/h"},
        {   86,  "|001STon/d"
                 "|049STon/d"},
        {   87,  "|001LTon/h"
                 "|049LTon/h"},
        {   88,  "|001LTon/d"
                 "|049LTon/d"},
        {   89,  "|001decatherm"
                 "|049decatherm"},
        {   90,  "|001SGU"
                 "|049SGU"},
        {   91,  "|001g/cm3"
                 "|049g/cm3"},
        {   92,  "|001kg/m3"
                 "|049kg/m3"},
        {   93,  "|001lb/gal"
                 "|049lb/gal"},
        {   94,  "|001lb/ft3"
                 "|049lb/ft3"},
        {   95,  "|001g/ml"
                 "|049g/ml"},
        {   96,  "|001kg/L"
                 "|049kg/L"},
        {   97,  "|001g/L"
                 "|049g/L"},
        {   98,  "|001lb/in3"
                 "|049lb/in3"},
        {   99,  "|001STon/yd3"
                 "|049STon/yd3"},
        {  100,  "|001degTwad"
                 "|049degTwad"},
        {  101,  "|001degBrix"
                 "|049degBrix"},
        {  102,  "|001degBaum hv"
                 "|049degBaum hv"},
        {  103,  "|001degBaum lt"
                 "|049degBaum lt"},
        {  104,  "|001degAPI"
                 "|049degAPI"},
        {  105,  "|001% sol/wt"
                 "|049% sol/wt"},
        {  106,  "|001% sol/vol"
                 "|049% sol/vol"},
        {  107,  "|001degBall"
                 "|049degBall"},
        {  108,  "|001proof/vol"
                 "|049proof/vol"},
        {  109,  "|001proof/mass"
                 "|049proof/mass"},
        {  110,  "|001bushel"
                 "|049bushel"},
        {  111,  "|001yd3"
                 "|049yd3"},
        {  112,  "|001ft3"
                 "|049ft3"},
        {  113,  "|001in3"
                 "|049in3"},
        {  120,  "|001m/h"
                 "|049m/h"},
        {  121,  "|001Nm3/h"
                 "|049Nm3/h"},
        {  122,  "|001NL/h"
                 "|049NL/h"},
        {  123,  "|001SCFM"
                 "|049SCFM"},
        {  124,  "|001bbl (liq)"
                 "|049bbl (liq)"},
        {  125,  "|001oz"
                 "|049oz"},
        {  126,  "|001ft-lb"
                 "|049ft-lb"},
        {  127,  "|001KW"
                 "|049KW"},
        {  128,  "|001KWH"
                 "|049KWH"},
        {  129,  "|001hp"
                 "|049hp"},
        {  130,  "|001CFH"
                 "|049CFH"},
        {  131,  "|001m3/min"
                 "|049m3/min"},
        {  132,  "|001bbl/s"
                 "|049bbl/s"},
        {  133,  "|001bbl/min"
                 "|049bbl/min"},
        {  134,  "|001bbl/h"
                 "|049bbl/h"},
        {  135,  "|001bbl/d"
                 "|049bbl/d"},
        {  136,  "|001gal/h"
                 "|049gal/h"},
        {  137,  "|001ImpGal/s"
                 "|049ImpGal/s"},
        {  138,  "|001L/h"
                 "|049L/h"},
        {  139,  "|001ppm"
                 "|049ppm"},
        {  140,  "|001Mcal/h"
                 "|049Mcal/h"},
        {  141,  "|001MJ/h"
                 "|049MJ/h"},
        {  142,  "|001Btu/h"
                 "|049Btu/h"},
        {  150,  "|001% stm qual"
                 "|049% stm qual"},
        {  152,  "|001ft3/lb"
                 "|049ft3/lb"},
        {  153,  "|001pF"
                 "|049pF"},
        {  160,  "|001% plato"
                 "|049% plato"},
        {  162,  "|001Mcal"
                 "|049Mcal"},
        {  163,  "|001kOhm"
                 "|049kOhm"},
        {  164,  "|001MJ"
                 "|049MJ"},
        {  165,  "|001Btu"
                 "|049Btu"},
        {  166,  "|001Nm3"
                 "|049Nm3"},
        {  167,  "|001NL"
                 "|049NL"},
        {  168,  "|001Sft3"
                 "|049Sft3"},
        {  235,  "|001gal/d"
                 "|049gal/d"},
        {  236,  "|001hl"
                 "|049hl"},
        {  237,  "|001MPa"
                 "|049MPa"},
        {  238,  "|001inH2O (4C)"
                 "|049inH2O (4C)"},
        {  239,  "|001mmH2O (4C)"
                 "|049mmH2O (4C)"},
        {  240,  "|001W"
                 "|049W"},
        {  241,  "|001MW"
                 "|049MW"},
        {  242,  "|001Mft3/d"
                 "|049Mft3/d"},
        {  245,  "|001WH"
                 "|049WH"},
        {  246,  "|001MWH"
                 "|049MWH"},
        {  247,  "|001J"
                 "|049J"},
        {  248,  "|001kJ"
                 "|049kJ"},
        {  249,  "|001kJ/kg"
                 "|049kJ/kg"},
        {  253,  "|001special"
                 "|049Spezial"}
    }
    HANDLING READ & WRITE;
}

VARIABLE mv_out_mass_flow_units
{
    LABEL "|001Process value unit"
          "|049Proz.wert Dimens.";
    HELP "|001Process value Unit- unit in which digital value,"
         " upper range value and lower range value are displayed. "
         "|049Prozesswert Dimension- Dimension mit der der digitale Wert, die"
         " obere Mebereichsgrenze und die untere Mebereichsgrenze behaftet sind.";
    TYPE ENUMERATED
    {
        {   15,  "|001ft3/min"
                 "|049ft3/min"},
        {   16,  "|001Gal/min"
                 "|049Gal/min"},
        {   17,  "|001L/min"
                 "|049L/min"},
        {   18,  "|001ImpGal/min"
                 "|049ImpGal/min"},
        {   19,  "|001m3/h"
                 "|049m3/h"},
        {   22,  "|001gal/s"
                 "|049gal/s"},
        {   23,  "|001Mgal/d"
                 "|049Mgal/d"},
        {   24,  "|001L/s"
                 "|049L/s"},
        {   25,  "|001ML/d"
                 "|049ML/d"},
        {   26,  "|001ft3/s"
                 "|049ft3/s"},
        {   27,  "|001ft3/d"
                 "|049ft3/d"},
        {   28,  "|001m3/s"
                 "|049m3/s"},
        {   29,  "|001m3/d"
                 "|049m3/d"},
        {   30,  "|001ImpGal/h"
                 "|049ImpGal/h"},
        {   31,  "|001ImpGal/d"
                 "|049ImpGal/d"},
        {   70,  "|001g/s"
                 "|049g/s"},
        {   71,  "|001g/min"
                 "|049g/min"},
        {   72,  "|001g/h"
                 "|049g/h"},
        {   73,  "|001kg/s"
                 "|049kg/s"},
        {   74,  "|001kg/min"
                 "|049kg/min"},
        {   75,  "|001kg/h"
                 "|049kg/h"},
        {   76,  "|001kg/d"
                 "|049kg/d"},
        {   77,  "|001t/min"
                 "|049t/min"},
        {   78,  "|001t/h"
                 "|049t/h"},
        {   79,  "|001t/d"
                 "|049t/d"},
        {   80,  "|001lb/s"
                 "|049lb/s"},
        {   81,  "|001lb/min"
                 "|049lb/min"},
        {   82,  "|001lb/h"
                 "|049lb/h"},
        {   83,  "|001lb/d"
                 "|049lb/d"},
        {   84,  "|001STon/min"
                 "|049STon/min"},
        {   85,  "|001STon/h"
                 "|049STon/h"},
        {   86,  "|001STon/d"
                 "|049STon/d"},
        {   87,  "|001LTon/h"
                 "|049LTon/h"}
        {   88,  "|001LTon/d"
                 "|049LTon/d"},
        {  130,  "|001ft3/h"
                 "|049ft3/h"},
        {  131,  "|001m3/min"
                 "|049m3/min"},
        {  132,  "|001bbl/s"
                 "|049bbl/s"},
        {  133,  "|001bbl/min"
                 "|049bbl/min"},
        {  134,  "|001bbl/h"
                 "|049bbl/h"},
        {  135,  "|001bbl/d"
                 "|049bbl/d"},
        {  136,  "|001gal/h"
                 "|049gal/h"},
        {  137,  "|001ImpGal/s"
                 "|049ImpGal/s"},
        {  138,  "|001L/h"
                 "|049L/h"},
        {  235,  "|001gal/d"
                 "|049gal/d"},
        {  242,  "|001Mft3/d"
                 "|049Mft3/d"},
        {  253,  "|001special"
                 "|049Spezial"}
    }
    HANDLING READ;
}

COLLECTION OF VARIABLE free_process
{
    LABEL "|001Process Value"
          "|049Prozesswert";
    HELP "|001Process value- depending on the device either pressure, different.pressure or mass/volume flow. "
         "|049Prozesswert- abhngig vom Gert entweder Druck, DiffDruck oder Masse/Volumenstrom.";
    MEMBERS
    {
        PERCENT_RANGE,	            pressure_percent_range, [percent_of_range], [percent_of_range_help];
        MINIMUM_SPAN,               pressure_minimum_span, [minimum_span], [minimum_span_help];
        TRANSFER_FUNCTION,          pressure_output_transfer_function, [transfer_function], [transfer_function_help];
        UPPER_SENSOR_LIMIT,         pressure_upper_range_limit, [usl], [upper_sensor_limit_help];
        LOWER_SENSOR_LIMIT,         pressure_lower_range_limit, [lsl], [lower_sensor_limit_help];
        DAMPING_VALUE,              pressure_damping_value, [damping_value], [seconds_damping_value_help];
        SENSOR_UNITS,               pressure_sensor_units, [sensor_unit], [sensor_minspan_unit_help];
        ANALOG_VALUE,               analog_output_value, [analog_output_value], [analog_value_help];
        SENSOR_SERIAL_NUMBER,       pressure_sensor_serial_number, [sensor_serial_number], [sensor_serial_number_help];
        ALARM_CODE,                 analog_output_alarm_select, [alarm_select], [alarm_code_help];
        IF (software_revision < 21)
        {
            DIGITAL_VALUE,              free_proc_var_stat_press, [blank], [digital_value_help];
        }
        ELSE
        {
            DIGITAL_VALUE,              free_process_variable, [blank], [digital_value_help];
        }
        IF (pbMultivariableFunction == 0)
        {
            DIGITAL_UNITS,              aidp_outscale_units, [units], [digital_units_help];
            UPPER_RANGE_VALUE,          aidp_outscale_100, [urv], [upper_range_value_help];
            LOWER_RANGE_VALUE,          aidp_outscale_0, [lrv], [lower_range_value_help];
        }
        ELSE
        {
            DIGITAL_UNITS,              mv_out_mass_flow_units, [units], [digital_units_help];
            UPPER_RANGE_VALUE,          mv_out_massflow_max_value, [urv], [upper_range_value_help];
            LOWER_RANGE_VALUE,          ptrbTrimmedValue, [lrv], [lower_range_value_help];
                                        /* wird vergewaltigt (s. a. Variablendefinition) */
        }
    }
}

UNIT free_process_variable_units_relation
{
    PV.DIGITAL_UNITS:
        PV.DIGITAL_VALUE,
        PV.UPPER_RANGE_VALUE,
        PV.LOWER_RANGE_VALUE
}


VARIABLE pressure_cal_units
{
    HELP "|001Field Device Variable Unit- Engineering unit to"
	     " be displayed with the Calibration Points."
	     " Pressure- Pressure of the process measured with respect to a reference pressure."
	     "|049Feldgerte Variablendimension- Dimension mit der die Kalibrierpunkte behaftet sind."
	     " Druck- Gemessener Prozedruck in Relation zu einem Bezugsdruck.";
    CLASS CORRECTION;
    LABEL "|001Pressure Calibration Unit";
    TYPE ENUMERATED
    {
        {    1,   "|001inH2O"
                  "|049inH2O"},
        {    2,   "|001inHg"
                  "|049inHg"},
        {    3,   "|001ftH2O"
                  "|049ftH2O"},
        {    4,   "|001mmH2O"
                  "|049mmH2O"},
        {    5,   "|001mmHg"
                  "|049mmHg"},
        {    6,   "|001psi"
                  "|049psi"},
        {    7,   "|001bar"
                  "|049bar"},
        {    8,   "|001mbar"
                  "|049mbar"},
        {    9,   "|001g/cm2"
                  "|049g/cm2"},
        {   10,   "|001kg/cm2"
                  "|049kg/cm2"},
        {   11,   "|001Pa"
                  "|049Pa"},
        {   12,   "|001kPa"
                  "|049kPa"},
        {   13,   "|001torr"
                  "|049torr"},
        {   14,   "|001atm"
                  "|049atm"},
        {  237,   "|001MPa"
                  "|049MPa"},
        {  253,   "|001special"
                  "|049Spezial"}
    }

    HANDLING READ & WRITE;

	POST_EDIT_ACTIONS
	{
		send_warning
	}

}
/* Auflistung aller mit der Druckdimension behafteter Variablen */
UNIT pressure_cal_units_relation
{
    pressure_cal_units:
        sensor_a_lower_sensor_trim_point,
        sensor_a_upper_sensor_trim_point,
        stat_press_sensor_lower_sensor_trim_point,
        stat_press_sensor_upper_sensor_trim_point
}

COLLECTION OF VARIABLE pressure
{
    LABEL "|001Pressure"
	      "|049Druck";
    HELP "|001Pressure- Variable that tracks the Digital Value representation"
	     " with respect to the range defined by the Lower Range Value and Upper Range"
	     " Value, for normal operating modes. All pressure units are possible."
	     "|049Druck- frei dimensionierbarer Mewert innerhalb des Mebereiches.";
    MEMBERS
    {
        DIGITAL_UNITS,		         pressure_units, [units], [digital_units_help];
        UPPER_RANGE_VALUE,           pressure_upper_range_value, [urv], [upper_range_value_help];
        LOWER_RANGE_VALUE,           pressure_lower_range_value, [lrv], [lower_range_value_help];
        IF ( software_revision < 21 )
            {
            DIGITAL_VALUE, free_process_variable, [blank], "|001Field Device Variable Value- Digital value that changes with respect to "
						      "process or ambient temperature over time with no user intervention. Sensor "
						      "Temperature- Temperature of the sensor wich measures the process."
						      "|049Feldgerte Variablenwert- Digitaler Prozessmewert oder "
						      "Umgebungstemperatur. Sensortemperatur- Temperatur des Sensors der den "
						      "Proze mit.";
            }
         ELSE
            {
            DIGITAL_VALUE, temperature_pressure_value, [blank], "|001Field Device Variable Value- Digital value that changes with respect to "
						      "process or ambient temperature over time with no user intervention. Sensor "
						      "Temperature- Temperature of the sensor wich measures the process."
						      "|049Feldgerte Variablenwert- Digitaler Prozessmewert oder "
						      "Umgebungstemperatur. Sensortemperatur- Temperatur des Sensors der den "
						      "Proze mit.";
            }
    }
}


/* Auflistung der Variablen, die mit der Druckdimension behaftet sind */

UNIT pressure_unit_relation
{
    pressure.DIGITAL_UNITS:
        pressure.DIGITAL_VALUE
}


/* Definition der Variablen fr die Sensortemperatur */

VARIABLE temperature_units
{
    LABEL "|001Snsr temp unit"
          "|049Snsr.-Temp.-Dim.";
    HELP "|001Field Device Variable Unit- Digital unit that the variable is displayed in."
	     " Sensor Temperature- Temperature of the sensor which measures the proccess."
	     "|049Feldgerte Variablendimension- Digitale Dimension mit der die Variable"
	     " angezeigt wird."
	     " Sensortemperatur- Temperatur des Sensors der den Proze mit.";
    TYPE ENUMERATED
    {
        {32,  "|001C"
              "|049C"},
        {33,  "|001F"
              "|049F"},
        {34,  "|001R"
              "|049R"},
        {35,  "|001K"
              "|049K"}
    }
    POST_EDIT_ACTIONS
    {
        temp_unit_action
    }
    HANDLING READ & WRITE;
    VALIDITY
        IF ( software_revision > 20 )
        {
            FALSE ;
        }
    CLASS CORRECTION;
}

VARIABLE  ptrbTemperatureValueUnitV21
{
    LABEL  "|001Snsr temp unit"
           "|049Snsr.-Temp.-Dim.";
    HELP "|001Field Device Variable Unit- Digital unit that the variable is displayed in."
         " Sensor Temperature- Temperature of the sensor which measures the proccess."
         "|049Feldgerte Variablendimension- Digitale Dimension mit der die Variable"
         " angezeigt wird."
         " Sensortemperatur- Temperatur des Sensors der den Proze mit.";
    CLASS  CORRECTION;
    TYPE ENUMERATED
    {
        {32,  "|001C"
              "|049C"},
        {33,  "|001F"
              "|049F"},
        {34,  "|001R"
              "|049R"},
        {35,  "|001K"
              "|049K"}
    }
    POST_EDIT_ACTIONS
    {
        temp_unit_action
    }
    HANDLING READ & WRITE;
    VALIDITY
        IF ( software_revision < 21 )
        {
            FALSE ;
        }
}


VARIABLE temperature_pressure_value
{
    HELP
        IF (software_revision < 21)
            {
                "|001Field Device Variable Value- Digital value that changes with respect to "
	            "process or ambient temperature over time with no user intervention. Sensor "
	            "Temperature- Temperature of the sensor wich measures the process."
	            "|049Feldgerte Variablenwert- Digitaler Prozessmewert oder "
	            "Umgebungstemperatur. Sensortemperatur- Temperatur des Sensors der den "
	            "Proze mit.";
            }
        ELSE
            {
                "|001Field Device Variable Value- Digital value that can change without user "
                "intervention. Pressure- Measured proccess pressure in relation to a "
                "reference pressure."
                "|049Feldgerte Variablenwert- Digitaler Wert der sich ndern kann ohne das der "
                "Benutzer eingreift. Druck- Gemessener Prozedruck in Relation zu einem "
                "Bezugsdruck.";
            }
    CLASS CORRECTION & DYNAMIC;
    LABEL
        IF (software_revision < 21)
            {
                [sensor_temperature];
            }
        ELSE
            {
                [pressure_value];
            }
    TYPE FLOAT
    {
        DISPLAY_FORMAT
        IF (software_revision < 21)
        {
            ".1f";
        }
        ELSE
        {
            SELECT (pressure_units)
            {
		        CASE 1:
		            ".3g";
		        CASE 2:
		            ".f";
		        CASE 3:
		            ".f";
		        CASE 4:
		            ".3g";
		        CASE 5:
		            ".3g";
		        CASE 6:
		            ".1f";
		        CASE 7:
		            ".2f";
		        CASE 8:
		            ".3g";
		        CASE 9:
		            ".3g";
		        CASE 10:
		            ".2f";
		        CASE 11:
		            ".3g";
		        CASE 12:
		            ".2f";
		        CASE 13:
		            ".3g";
		        CASE 14:
		            ".2f";
            }
        }
    }
    HANDLING READ;
}

VARIABLE  ptrbTemperatureValueV21
{
    LABEL  "|001Sensor temp"
           "|049Sensortemp.";
    CLASS  CORRECTION & DYNAMIC;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".1f";
    }
    HANDLING READ;
    VALIDITY
        IF ( software_revision < 21 )
        {
            FALSE ;
        }
}


COLLECTION OF VARIABLE temperature
{
    LABEL [sensor_temperature];
    HELP "|001Sensor Temperature- Temperature of the sensor which measures the proccess."
	     "|049Sensortemperatur- Temperatur des Sensors der den Proze mit.";
    MEMBERS
    {
    IF ( software_revision < 21 )
        {
        DIGITAL_UNITS, temperature_units, [units], "|001Field Device Variable Unit- Digital unit that the variable is displayed in. "
						  "Sensor Temperature- Temperature of the sensor which measures the proccess."
						  "|049Feldgerte Variablendimension- Digitale Dimension mit der die Variable "
						  "angezeigt wird. Sensortemperatur- Temperatur des Sensors der den Proze "
						  "mit.";
        DIGITAL_VALUE, temperature_pressure_value, [blank], "|001Field Device Variable Value- Digital value that changes with respect to "
						  "process or ambient temperature over time with no user intervention. Sensor "
						  "Temperature- Temperature of the sensor wich measures the process."
						  "|049Feldgerte Variablenwert- Digitaler Prozessmewert oder "
						  "Umgebungstemperatur. Sensortemperatur- Temperatur des Sensors der den "
						  "Proze mit.";
        }
    ELSE
        {
        DIGITAL_UNITS, ptrbTemperatureValueUnitV21, [units], "|001Field Device Variable Unit- Digital unit that the variable is displayed in. "
						  "Sensor Temperature- Temperature of the sensor which measures the proccess."
						  "|049Feldgerte Variablendimension- Digitale Dimension mit der die Variable "
						  "angezeigt wird. Sensortemperatur- Temperatur des Sensors der den Proze "
						  "mit.";
        DIGITAL_VALUE, ptrbTemperatureValueV21, [blank], "|001Field Device Variable Value- Digital value that changes with respect to "
						  "process or ambient temperature over time with no user intervention. Sensor "
						  "Temperature- Temperature of the sensor wich measures the process."
						  "|049Feldgerte Variablenwert- Digitaler Prozessmewert oder "
						  "Umgebungstemperatur. Sensortemperatur- Temperatur des Sensors der den "
						  "Proze mit.";
        }
    }
}


/* Auflistung der Variablen, die mit der Temperaturdimension behaftet sind */

UNIT temperature_units_relation
{
    temperature.DIGITAL_UNITS:
        temperature.DIGITAL_VALUE
}



/* Definition der Variablen fr den stat. Druck */

VARIABLE  static_press_proc_temp
{
    LABEL
        IF (software_revision < 21)
        {
            "|001Stat pres"
            "|049St Druck";
        }
        ELSE
        {
            "|001Process temp."
            "|049Prozesstemp.";
        }
    HELP    [digital_value_help];
    HANDLING READ;
    CLASS  CORRECTION & DYNAMIC;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".1f";
    }
    VALIDITY
            /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF (((software_revision < 21) && (module_type_code >= 30)) ||    /* ab 30 sind Codes fr Druckmewerke */
            /* Prozetemperatur nur bei multivariablen Gerten anzeigen */
            ((software_revision > 20) && (pbMultivariableFunction == 0)))
        {
            FALSE;
        }
}


VARIABLE static_pressure_units
{
    LABEL "|001Stat pres unit|049Stat Drk Dim.";
    HELP "|001Field Device Variable Unit- unit in which digital value is displayed."
         " Static pressure- Static pressure of the sensor which measures the proccess."
         "|049Feldgerte Variablendimension- Dimension mit der der digitale Wert behaftet ist."
         " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
    TYPE ENUMERATED
    {
        {    1,   "|001inH2O"
                  "|049inH2O"},
        {    2,   "|001inHg"
                  "|049inHg"},
        {    3,   "|001ftH2O"
                  "|049ftH2O"},
        {    4,   "|001mmH2O"
                  "|049mmH2O"},
        {    5,   "|001mmHg"
                  "|049mmHg"},
        {    6,   "|001psi"
                  "|049psi"},
        {    7,   "|001bar"
                  "|049bar"},
        {    8,   "|001mbar"
                  "|049mbar"},
        {    9,   "|001g/cm2"
                  "|049g/cm2"},
        {   10,   "|001kg/cm2"
                  "|049kg/cm2"},
        {   11,   "|001Pa"
                  "|049Pa"},
        {   12,   "|001kPa"
                  "|049kPa"},
        {   13,   "|001torr"
                  "|049torr"},
        {   14,   "|001atm"
                  "|049atm"},
        {  237,   "|001MPa"
                  "|049MPa"},
        {  253,   "|001special"
                  "|049Spezial"}
    }
    HANDLING
        IF ( pbMultivariableFunction > 0 )
        {
            READ;
        }
        ELSE
        {
            READ & WRITE;
        }
    PRE_EDIT_ACTIONS
    {
        store_old_stat_press_unit
    }
    POST_EDIT_ACTIONS
    {
        calc_new_stat_pressure_range_values
    }
    VALIDITY
        /* stat. Druckdimension nur bei Differenzdruckmeumformer anzeigbar/nderbar */
        IF (module_type_code >= 30)    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}

VARIABLE static_pressure_upper_range_value
{
    CLASS INPUT;
    LABEL [pressure_upper_range_value];
    TYPE FLOAT;
    HANDLING
        IF ( pbMultivariableFunction > 0 )
        {
            READ ;
        }
        ELSE
        {
            READ & WRITE;
        }
}

VARIABLE static_pressure_lower_range_value
{
    CLASS INPUT;
    LABEL [pressure_lower_range_value];
    TYPE FLOAT;
    HANDLING
        IF ( pbMultivariableFunction > 0 )
        {
            READ ;
        }
        ELSE
        {
            READ & WRITE;
        }
}


VARIABLE stat_press_sensor_lower_sensor_trim_point
{
    HELP "|001Stat. Pressure Lower Sensor Trim Point- Applied process pressure at which the last"
    	 " low sensor trim was performed."
	     " Stat. Pressure Sensor- Pressure hardware that measures pressure with respect"
         " to a reference pressure."
         "|049Unterer stat. Drucksensorabgleichpunkt- Angelegter Prozedruck bei dem der letzte "
         " unterer Sensorabgleich vorgenommen wurde."
         " Stat. Drucksensor- Konstruktion die den stat. Druck in Relation zu einem Bezugsdruck mit.";

    LABEL  "|001Stat Pr sns LST pt"
		   "|049Stat Dr unt.Abgpkt";
    CLASS CORRECTION;
    TYPE FLOAT
    {
	    DISPLAY_FORMAT ".3f";
	    EDIT_FORMAT "6.3f";
    }
    HANDLING READ & WRITE;
    VALIDITY
        /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF (module_type_code >= 30)    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}

VARIABLE stat_press_sensor_upper_sensor_trim_point
{
	HELP "|001Stat. Pressure Upper Sensor Trim Point- Applied process pressure at which the last"
	     " upper sensor trim was performed."
	     " Stat. Pressure Sensor- Pressure hardware that measures pressure with respect"
	     " to a reference pressure."
	     "|049Oberer stat. Drucksensorabgleichpunkt- Angelegter Prozedruck bei dem der letzte "
	     " obere Sensorabgleich vorgenommen wurde."
	     " Stat. Drucksensor- Konstruktion die den stat. Druck in Relation zu einem Bezugsdruck mit.";

    LABEL  "|001Stat Pr sns UST pt"
    	   "|049Stat Dr ob.Abgpkt";
    CLASS CORRECTION;
    TYPE FLOAT
    {
	    DISPLAY_FORMAT ".3f";
	    EDIT_FORMAT "6.3f";
    }
    HANDLING READ & WRITE;
    VALIDITY
        /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF (module_type_code >= 30)    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}


VARIABLE static_pressure_hi_lim
{
    LABEL "|001Stat pres USL|049Stat Druck ob.Mbgrz.";
    HELP "|001Upper Sensor Limit Value- Defines the maximum value able to be used for the static"
         " pressure upper range value."
         " Static pressure- Static pressure of the sensor which measures the proccess."
         "|049Wert obere Mebereichsgrenze- bestimmt den max. nutzbaren Wert fr das Meende stat. Druck."
         " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
    CLASS CORRECTION;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2f";
    }
    HANDLING READ;
    VALIDITY
        /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF (module_type_code >= 30)    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}


VARIABLE static_pressure_lo_lim
{
    LABEL "|001Stat pres LSL|049Stat Druck unt.Mbgrz.";
    HELP "|001Lower Sensor Limit Value- Defines the lowest allowable value for the static "
         " pressure lower range value."
         " Static pressure- Static pressure of the sensor which measures the proccess."
         "|049Wert untere Mebereichsgrenze- bestimmt den min. nutzbaren Wert fr den Meanfang stat. Druck."
         " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
    CLASS CORRECTION;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2f";
    }
    HANDLING READ;
    VALIDITY
        /* stat. Druck nur bei Differenzdruckmeumformer anzeigen */
        IF (module_type_code >= 30)    /* ab 30 sind Codes fr Druckmewerke */
        {
            FALSE;
        }
}


COLLECTION OF VARIABLE stat_pressure
{
    LABEL    "|001Stat pres|049Stat Drk";
    HELP     "|001Field Device Variable Value- Digital value that"
	         " changes magnitude with respect to time with no user intervention."
             " Static pressure- Static pressure of the sensor which measures the proccess."
             "|049Feldgerte Variablenwert- Statischer Druck."
             " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
    MEMBERS
    {
        DIGITAL_UNITS, static_pressure_units, "|001Stat pres unit|049Stat Drk Dim.",
                        "|001Field Device Variable Unit- Digital unit that the variable is displayed in."
    				    " Static pressure- Static pressure of the sensor which measures the proccess."
    				    "|049Feldgerte Variablendimension- Digitale Dimension mit der die Variable"
    				    " angezeigt wird."
    				    " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
        IF ( software_revision < 21 )
        {
            DIGITAL_VALUE, static_press_proc_temp, [blank], "|001Field Device Variable Value- Digital value that changes with respect to"
						    " static pressure over time with no user intervention."
						    " Static pressure- Static pressure of the sensor which measures the proccess."
						    "|049Feldgerte Variablenwert- Statischer Druck."
                            " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
        }
        ELSE
        {
            DIGITAL_VALUE, free_proc_var_stat_press, [blank], "|001Field Device Variable Value- Digital value that changes with respect to"
                            " static pressure over time with no user intervention."
                            " Static pressure- Static pressure of the sensor which measures the proccess."
                            "|049Feldgerte Variablenwert- Statischer Druck."
                            " Statischer Druck- Statischer Druck des Sensors der den Proze mit.";
        }
    }
}


/* Auflistung der Variablen, die mit der stat. Druckdimension behaftet sind */

UNIT stat_pressure_units_relation
{
    stat_pressure.DIGITAL_UNITS:
        stat_pressure.DIGITAL_VALUE
}



/* Definition der Variablen fr die Prozetemperatur */

VARIABLE process_temp_units
{
    LABEL "|001Process temp. unit"
          "|049Dim. Prozesstemp";
    HELP "|001Process temp unit- Digital unit that the process temperature is displayed in."
         " Process Temperature- Temperature of the sensor which measures the proccess."
         "|049Dim. Prozesstemp.- Digitale Dimension mit der die Prozetemperatur angezeigt wird."
         " Prozetemperatur- Temperatur des Sensors der den Proze mit.";
    TYPE ENUMERATED
    {
        {   32,   "|001C"
                  "|049C"},
        {   33,   "|001F"
                  "|049F"},
        {   34,   "|001R"
                  "|049R"},
        {   35,   "|001K"
                  "|049K"},
        {  253,   "|001special"
                  "|049Spezial"}
    }
}


COLLECTION OF VARIABLE process_temp
{
    LABEL "|001Proc Temp|049Proz. Temp";
    HELP "|001Proccess Temperature- Temperature of the sensor which measures the proccess."
	     "|049Prozetemperatur- Temperatur des Sensors der den Proze mit.";
    MEMBERS
    {
    IF ( software_revision < 21 )
        {
        DIGITAL_UNITS, ptrbTemperatureValueUnitV21;     /* Dummys, da bei SW-Versionen < 21 diese Variablen */
        DIGITAL_VALUE, ptrbTemperatureValueV21;         /* nicht gltig sind. */
        }
    ELSE
        {
        DIGITAL_UNITS, process_temp_units, [units], "|001Field Device Variable Unit- Digital unit that the"
                          " process temperature is displayed in."
						  " Proccess Temperature- Temperature of the sensor which measures the proccess."
						  "|049Feldgerte Variablendimension- Digitale Dimension mit der die Prozetemperatur"
						  " angezeigt wird."
						  " Prozetemperatur- Temperatur des Sensors der den Proze mit.";
        DIGITAL_VALUE, static_press_proc_temp, [blank], "|001Field Device Variable Value- Digital value that"
                          " changes with respect to process temperature over time with no user intervention."
						  " Proccess Temperature- Temperature of the sensor wich measures the process."
						  "|049Feldgerte Variablenwert- Digitale Prozesstemperatur."
						  " Prozetemperatur- Temperatur des Sensors der den Proze mit.";
        }
    }
}


/* Auflistung der Variablen, die mit der Temperaturdimension behaftet sind */

UNIT process_temp_units_relation
{
    process_temp.DIGITAL_UNITS:
        process_temp.DIGITAL_VALUE
}


/******************************************************************************
 * Definition des ARRAY OF COLLECTION dynamic_variables
 */

ARRAY OF COLLECTION dynamic_variables
{
   HELP "|001Primary Variable- Primary variable of the process. Secondary Variable- "
	"Secondary variable of the process. Tertiary Variable- Tertiary variable of "
	"the process."
	"|049Hauptvariable- Hauptmewert vom Proze. Zweite Variable- Zweiter Mewert "
	"vom Proze. Dritte Variable- Dritter Mewert vom Proze.";
   ELEMENTS
   {
       PRIMARY, free_process, [pv], [primary_variable_help];
       SECONDARY, temperature, [sv], [secondary_variable_help];
       TERTIARY, pressure, [tv], [tertiary_variable_help];
   }
}




/******************************************************************************
 * Definition der Variablen fr die privaten Kommandos
 */

VARIABLE remote_seal_fill_fluid
{
   LABEL [remote_seal_fill_fluid];
   HELP "|001Remote Seal Fill Fluid- Type of fluid in the device's remote seal."
	    "|049Druckmittler Fllflssigkeit- Art der Flssigkeit im Gertedruckmittler.";
   TYPE ENUMERATED
   {
       {   1,   [silicone_oil] },
       {   2,   "|001Fluor carbon"
                "|049Fluorkohlenstoff" },
       {   3,   "|001Destilled water"
                "|049Destilliertes Wasser" },
       {   4,   "|001High temperature oil"
                "|049Hochtemperaturl" },
       {   5,   "|001Vegetable Oil"
                "|049Pflanzenl"},
       {   6,   "|001Mineral oil"
                "|049Minerall"},
       {   7,   "|001White oil"
                "|049Weissl"},
       {   8,   "|001Fill fluid FDA certified"
                "|049Fllflssigkeit FDA zugelassen"},
       {   9,   "|001Fill fluid ABB"
                "|049Fllflssigkeit ABB"},
       { 251,   [none] },
       { 253,   [special] }
   }
   CLASS DEVICE;
}


VARIABLE module_range_code
{
    LABEL [module_range];
    HELP "|001Module Range Code- code for the measurement range of the transmitter's measurement cell."
	     "|049Mebereichscode der Mezelle- Kodierung fr den Mebereich der Mezelle des Gertes";
    TYPE ENUMERATED
    {
        {   1,  "|00110 mbar"
                "|04910 mbar" },
        {   2,  "|00125 mbar"
                "|04925 mbar" },
        {   3,  "|00160 mbar"
	            "|04960 mbar" },
        {   4,  "|001160 mbar"
	            "|049160 mbar" },
        {   5,  "|001400 mbar"
	            "|049400 mbar" },
        {   6,  "|0011 bar"
    	        "|0491 bar" },
        {   7,  "|0012.5bar"
	            "|0492.5bar" },
        {   8,  "|0016 bar"
    	        "|0496 bar" },
        {   9,  "|00116 bar"
	            "|04916 bar" },
        {  10,  "|00140 bar"
	            "|04940 bar" },
        {  11,  "|001100 bar"
	            "|049100 bar" },
        {  12,  "|001250 bar"
	            "|049250 bar" },
        {  13,  "|001600 bar"
	            "|049600 bar" }
        {  15,  "|00120 bar"
	            "|04920 bar" }
        {  16,  "|00130 bar"
	            "|04930 bar" }
        {  17,  "|001410 bar"
	            "|049410 bar" }
        {  18,  "|00112.5 mbar"
	            "|04912.5 mbar" }
   }
   HANDLING READ;
   CLASS DEVICE;
}


VARIABLE rated_pressure
{
    LABEL "|001Rated Pressure"
          "|049Nenndruck";
    HELP "|001Rated Pressure- Highest operating pressure which may be applied"
	     " simultaneously to both measuring chambers."
	     "|049Nenndruck- Grter Betriebsdruck, der auf beide Mekammern gleichzeitig"
	     " wirken darf.";
    CLASS DEVICE;
    TYPE ENUMERATED
    {
        {   1,  "|0012.5 bar"
	            "|0492.5 bar" },
        {   2,  "|0016 bar"
	            "|0496 bar" },
        {   3,  "|00116 bar"
	            "|04916 bar" },
        {   4,  "|00125 bar"
	            "|04925 bar" },
        {   5,  "|00140 bar"
	            "|04940 bar" },
        {   6,  "|001100 bar"
	            "|049100 bar" },
        {   7,  "|001250 bar"
	            "|049250 bar" },
        {   8,  "|001400 bar"
	            "|049400 bar" },
        {  10,  "|00163 bar"
	            "|04963 bar" },
        {  11,  "|00164 bar"
	            "|04964 bar" },
        {  12,  "|001160 bar"
	            "|049160 bar" },
        {  13,  "|001600 bar"
	            "|049600 bar" },
        {  14,  "|00110 bar"
	            "|04910 bar" },
        {  15,  "|001410 bar"
	            "|049410 bar" },
        {  20,  "|001150 psi"
	            "|049150 psi" },
        {  21,  "|001300 psi"
	            "|049300 psi" },
        {  22,  "|001600 psi"
	            "|049600 psi" },
        {  23,  "|0011500 psi"
	            "|0493600 psi" },
        {  24,  "|0011500 psi"
	            "|0493600 psi" },
        {  25,  "|00120 bar"
	            "|04920 bar" },
        { 251,  [none] },
        { 253,  [special] }
    }
    HANDLING READ;
}


VARIABLE highAlarmCurr
{
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2e";
    }
    HANDLING READ & WRITE;
}

VARIABLE lowAlarmCurr
{
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2e";
    }
    HANDLING READ & WRITE;
}

VARIABLE maxOutputCurr
{
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2e";
    }
    HANDLING READ & WRITE;
}

VARIABLE minOutputCurr
{
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".2e";
    }
    HANDLING READ & WRITE;
}

VARIABLE pbWriteLock
{
    LABEL "|001Soft Write Lock"
          "|049Softwareschreibschutz";
    HELP "|001Soft Write Lock- possibility to write lock the device without a key."
         "|049Softwareschreibschutz-bietet die Mglichkeit das Gert ohne Schreibschutzschalter"
         " in Schreibschutz zu setzen";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED (2)
    {
        {   0,  "|001on"
                "|049aktiviert"},
        {2457,  "|001off"
                "|049aufgehoben"}
    }
}


VARIABLE ptrbFlowLinSqrtPoint
{
    LABEL "|001LinSqrPoint"
          "|049Li/Rd berg.";
    HELP "|001LinSqrtPoint- Transition point from linear to square root calculation and vice versa."
               "Adjustment range : 5...20%"
         "|049Lin/Rad bergangsPkt- bergangspunkt von linearer zu radizierender Berechnung."
         "Einstellbereich : 5...20%";
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".1f";
        MIN_VALUE 5.0;
        MAX_VALUE 20.0;
    }
    CONSTANT_UNIT "%";
    HANDLING READ & WRITE;
}

VARIABLE ptrbLowFlowCutOff
{
    LABEL "|001Lo flw cut"
          "|049Nullrcker";
    HELP "|001Low Flow Cutoff- Set point that determines when the process"
         " variable will indicate 0 rather than some nominally small value."
         "Adjustment range : 0...15%"
         "|049Nullrcker- Kleinere berechnete Werte als dieser Wert werden unterdrckt"
         " und zu 0 gesetzt. Einstellbereich : 0...15%";
    CLASS DEVICE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".1f";
        MIN_VALUE 0.0;
        MAX_VALUE 15.0;
    }
    CONSTANT_UNIT "%";
    HANDLING READ & WRITE;
}

VARIABLE ptrbTabActualNumber
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE ptrbModeBlkActual
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ;
}

VARIABLE ptrbPrimaryValue
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ;
}

VARIABLE ptrbPrimaryValueStatus
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ;
}


/* Diese Variable wird als untere Durchflumebereichsgrenze  */
/* vergewaltigt. Sie wird nach dem Lesen immer auf 0 gesetzt. */
VARIABLE ptrbTrimmedValue
{
    LABEL "|001Proc. LRV"
          "|049Proz. MBA";
    HELP "|001Process value, lower range value"
         "|049Prozesswert, Messbereichsanfang";
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ;
    POST_READ_ACTIONS
    {
        set_flow_lrv_zero
    }
}

METHOD set_flow_lrv_zero
{
    LABEL "set_flow_lrv_zero";
    DEFINITION
    {
		fsetval(0.0);
    }
}

VARIABLE ptrbTrimmedValueStatus
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ;
}

VARIABLE ptrbSecondaryValue1Status
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ;
}

VARIABLE ptrbStaticPressureValueStatus
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ;
}

VARIABLE ptrbStaticPressureMinSpan
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ;
}

VARIABLE static_pressure_decimal
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE pbMultivariableFunction
{
    CLASS DEVICE;
    TYPE ENUMERATED
    {
        {   0,  "|001OFF"
                "|049AUS"},
        {   1,  "|001ON"
                "|049EIN"}
    }
    HANDLING READ;
}

VARIABLE aidp_outscale_0
{
    LABEL "|001Proc. LRV"
          "|049Proz. MBA";
    HELP "|001Process value, lower range value"
	     "|049Prozesswert, Messbereichsanfang";
    CLASS ANALOG_OUTPUT;
    TYPE FLOAT;
    HANDLING READ & WRITE;
}

VARIABLE aidp_outscale_100
{
    LABEL "|001Proc. URV"
          "|049Proz. MBE";
    HELP "|001Process value, upper range value"
	     "|049Prozesswert, Messbereichsende";
    CLASS ANALOG_OUTPUT;
    TYPE FLOAT;
    HANDLING READ & WRITE;
}

VARIABLE aidp_outscale_decimal
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_dp_unit
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_dp_default
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_p_unit
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_p_default
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_t_unit
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE mv_in_t_default
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ & WRITE;
}

VARIABLE mv_out_massflow_max_value
{
    LABEL "|001Proc. URV"
          "|049proz. MBE";
    HELP "|001Process value, upper range value"
         "|049Prozesswert, Messbereichsende";
    CLASS ANALOG_OUTPUT;
    TYPE FLOAT;
    HANDLING READ;
}

VARIABLE mv_out_volflow_max_value
{
    CLASS DEVICE;
    TYPE FLOAT;
    HANDLING READ;
}

VARIABLE mv_out_volflow_unit
{
    CLASS DEVICE;
    TYPE INTEGER;
    HANDLING READ & WRITE;
}

VARIABLE pb_device_id
{
    LABEL "|001Model"
	      "|049Gertetyp";
    CLASS DEVICE;
    TYPE ASCII (16);
    HANDLING READ;
}


/* Definition der privaten Kommandos */


/*  Kommando #128  */

COMMAND read_static_data_material
{
    NUMBER 128;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {}
        REPLY
        {
	    response_code, device_status,
	    flange_type, flange_material,
	    o_ring_material, meter_installation, drain_vent_material,
	    remote_seal_type, remote_seal_fill_fluid, remote_seal_isolator_material,
	    number_of_remote_seals, module_fill_fluid, module_isolator_material,
	    module_type_code, module_range_code,
	    pressure_cal_units, sensor_a_upper_sensor_trim_point, sensor_a_lower_sensor_trim_point,
	    local_keys_mode_control_codes, pbWriteLock, rated_pressure
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #129  */

COMMAND write_static_data_material
{
    NUMBER 129;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
	    flange_type, flange_material, o_ring_material,
	    drain_vent_material, remote_seal_type, remote_seal_fill_fluid,
	    remote_seal_isolator_material, number_of_remote_seals
        }
        REPLY
        {
        response_code, device_status,
        flange_type, flange_material, o_ring_material,
        drain_vent_material, remote_seal_type, remote_seal_fill_fluid,
        remote_seal_isolator_material, number_of_remote_seals
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
    }
}


/*  Kommando #132  */

COMMAND local_keys_mode_control
{
    NUMBER 132;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
	    local_keys_mode_control_codes,
	    meter_installation
        }
        REPLY
        {
	    response_code, device_status,
	    local_keys_mode_control_codes,
	    meter_installation
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
    }
}


/*  Kommando #133  */

COMMAND read_sensor_temp
{
    NUMBER 133;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        { }
        REPLY
        {
	        response_code, device_status,
	        ptrbModeBlkActual, ptrbPrimaryValue, ptrbPrimaryValueStatus,
	        ptrbTrimmedValue, ptrbTrimmedValueStatus,
	        ptrbSecondaryValue1Status, ptrbStaticPressureValueStatus,
	        ptrbTemperatureValueV21, ptrbTemperatureValueUnitV21,
            0, 0, 0, 0, 0, 0
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #141 */

COMMAND write_sw_write_lock
{
    NUMBER 141;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            pbWriteLock
        }
        REPLY
        {
            response_code, device_status,
            pbWriteLock
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
    }
}


/*  Kommando #150 */

COMMAND read_pb_device_id
{
    NUMBER 150;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        { }
        REPLY
        {
	    response_code, device_status,
	    pb_device_id
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #164  */

COMMAND read_outscale
{
    NUMBER 164;
    OPERATION READ;
    TRANSACTION 0
    {
        REQUEST
        {
            2
        }
        REPLY
        {
	        response_code, device_status,
	        2, aidp_outscale_units, aidp_outscale_100, aidp_outscale_0,
	        aidp_outscale_decimal
        }
    }
    TRANSACTION 1
    {
        REQUEST
        {
            13
        }
        REPLY
        {
            response_code, device_status,
            13, static_pressure_units, static_pressure_upper_range_value, static_pressure_lower_range_value,
            static_pressure_decimal
        }
    }
    TRANSACTION 2
    {
        REQUEST
        {
            14
        }
        REPLY
        {
            response_code, device_status,
            14, 0, static_pressure_hi_lim, static_pressure_lo_lim,
            0
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #165  */

COMMAND write_outscale
{
    NUMBER 165;
    OPERATION WRITE;
    TRANSACTION 0
    {
        REQUEST
        {
            2, aidp_outscale_units, aidp_outscale_100, aidp_outscale_0,
            aidp_outscale_decimal
        }
        REPLY
        {
	        response_code, device_status,
	        2, aidp_outscale_units, aidp_outscale_100, aidp_outscale_0,
	        aidp_outscale_decimal
        }
    }
    TRANSACTION 1
    {
        REQUEST
        {
            13, static_pressure_units, static_pressure_upper_range_value, static_pressure_lower_range_value,
            static_pressure_decimal
        }
        REPLY
        {
            response_code, device_status,
            13, static_pressure_units, static_pressure_upper_range_value, static_pressure_lower_range_value,
            static_pressure_decimal
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #186  */

COMMAND read_mv_parameter
{
    NUMBER 186;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
	        response_code, device_status,
	        mv_in_dp_unit, mv_in_dp_default, mv_in_p_unit, mv_in_p_default,
	        mv_in_t_unit, mv_in_t_default,mv_out_mass_flow_units,
	        mv_out_massflow_max_value, mv_out_volflow_unit,
	        mv_out_volflow_max_value
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #187  */

COMMAND write_mv_parameter
{
    NUMBER 187;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
	        mv_in_dp_unit, mv_in_dp_default, mv_in_p_unit, mv_in_p_default,
	        mv_in_t_unit, mv_in_t_default,mv_out_mass_flow_units,
	        mv_out_massflow_max_value, mv_out_volflow_unit,
	        mv_out_volflow_max_value
        }
        REPLY
        {
	        response_code, device_status,
	        mv_in_dp_unit, mv_in_dp_default, mv_in_p_unit, mv_in_p_default,
	        mv_in_t_unit, mv_in_t_default,mv_out_mass_flow_units,
	        mv_out_massflow_max_value, mv_out_volflow_unit,
	        mv_out_volflow_max_value
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #206  */

COMMAND read_multivariable_function
{
    NUMBER 206;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        { }
        REPLY
        {
	        response_code, device_status,
	        pbMultivariableFunction
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #222 */

COMMAND read_sv_units
{
    NUMBER 222;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        { }
        REPLY
        {
	        response_code, device_status,
	        ptrbFlowLinSqrtPoint, ptrbTabActualNumber, ptrbLowFlowCutOff,
	        pressure_cal_units, ptrbStaticPressureMinSpan,
	        stat_press_sensor_upper_sensor_trim_point, stat_press_sensor_lower_sensor_trim_point
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #223 */

COMMAND write_sv_units
{
    NUMBER 223;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            ptrbFlowLinSqrtPoint, ptrbTabActualNumber, ptrbLowFlowCutOff,
	        temperature.DIGITAL_UNITS
        }
        REPLY
        {
	        response_code, device_status,
	        ptrbFlowLinSqrtPoint, ptrbTabActualNumber, ptrbLowFlowCutOff,
	        temperature.DIGITAL_UNITS
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
    }
}


/*  Kommando #227 */

COMMAND write_stat_press_upp_cal_point
{
    NUMBER 227;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            pressure_cal_units, stat_press_sensor_upper_sensor_trim_point
        }
        REPLY
        {
	        response_code, device_status,
            pressure_cal_units, stat_press_sensor_upper_sensor_trim_point
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        3, DATA_ENTRY_ERROR, [passed_parameter_too_large];
        4, DATA_ENTRY_ERROR, [passed_parameter_too_small];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
        9, PROCESS_ERROR, [applied_process_too_high];
       10, PROCESS_ERROR, [applied_process_too_low];
       14, DATA_ENTRY_ERROR, [span_too_small];
       17, MISC_ERROR, "|001Invalid float format|049ungltige Gleitkommazahl";
       29, MISC_ERROR, "|001Setting not accepted|049Kalibrierung fehlgeschlagen";
    }
}


/*  Kommando #228 */

COMMAND write_stat_press_low_cal_point
{
    NUMBER 228;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            pressure_cal_units, stat_press_sensor_lower_sensor_trim_point
        }
        REPLY
        {
	        response_code, device_status,
            pressure_cal_units, stat_press_sensor_lower_sensor_trim_point
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        3, DATA_ENTRY_ERROR, [passed_parameter_too_large];
        4, DATA_ENTRY_ERROR, [passed_parameter_too_small];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
        9, PROCESS_ERROR, [applied_process_too_high];
       10, PROCESS_ERROR, [applied_process_too_low];
       14, DATA_ENTRY_ERROR, [span_too_small];
       17, MISC_ERROR, "|001Invalid float format|049ungltige Gleitkommazahl";
       29, MISC_ERROR, "|001Setting not accepted|049Kalibrierung fehlgeschlagen";
    }
}


/*  Kommando #248  */

COMMAND read_alarm_selection_code
{
    NUMBER 248;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        { }
        REPLY
        {
	        response_code, device_status,
	        highAlarmCurr, lowAlarmCurr, maxOutputCurr, minOutputCurr
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
    }
}


/*  Kommando #249  */

COMMAND write_alarm_selection_code
{
    NUMBER 249;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
	        highAlarmCurr, lowAlarmCurr, maxOutputCurr, minOutputCurr,
	        PV.ALARM_CODE
        }
        REPLY
        {
	        response_code, device_status,
	        highAlarmCurr, lowAlarmCurr, maxOutputCurr, minOutputCurr,
	        PV.ALARM_CODE
        }
    }
    RESPONSE_CODES
    {
        0, SUCCESS, [no_command_specific_errors];
        2, DATA_ENTRY_ERROR, [invalid_selection];
        5, MISC_ERROR, [too_few_data_bytes_recieved];
        7, MODE_ERROR, [in_write_protect_mode];
    }
}



/******************************************************************************/
/*   Definition neuer Methoden  */

#define MAXIMUM_SELFTEST_TIME               30          /* increased from 15 */
#define WRITE_PROTECTED                     7
#define DEVICE_BUSY                         32
#define MORE_STATUS_AVAILABLE               0x10
#define HARDWARE_FAILURE_ELECTRONIC         0x01        /* diagnosis */
#define MEMORY_ERROR                        0x10        /* diagnosis */
#define FAIL_MEASUREMENT                    0x20        /* diagnosis */
#define CONFIG_NOT_VALID                    0x04        /* diagnosis */
#define ELECTR_EEPROM_ERROR                 0x01        /* diagnosisExtension */
#define SENSOR_EEPROM_ERROR                 0x02        /* diagnosisExtension */
#define ELECTR_MAX_WRITE_CYCLES             0x04        /* diagnosisExtension */
#define SENSOR_MAX_WRITE_CYCLES             0x08        /* diagnosisExtension */
#define ELECTR_DATA_ERROR                   0x10        /* diagnosisExtension */
#define SENSOR_DATA_ERROR                   0x20        /* diagnosisExtension */
#define CONFIG_DATA_ERROR                   0x40        /* diagnosisExtension */
#define FACTORY_DATA_ERROR                  0x80        /* diagnosisExtension */
#define EEPROM_DATA_SAVE                    0x02        /* diagnosisExtension */
#define DEVICE_IS_BUSY                      0x10        /* diagnosisExtension */
#define CYCLIC_DATA_LEN_ERROR               0x20        /* diagnosisExtension */
#define CYCLIC_DATA_NOT_READABLE            0x40        /* diagnosisExtension */
#define CYCLIC_DATA_NOT_WRITEABLE           0x80        /* diagnosisExtension */
#define ALARM_ROM                           0x01        /* diagnosisExtension */
#define ALARM_INT_RAM                       0x02        /* diagnosisExtension */
#define ALARM_EXT_RAM                       0x04        /* diagnosisExtension */
#define STATUS_CURR_MIN                     0x20        /* diagnosisExtension */
#define STATUS_CURR_MAX                     0x40        /* diagnosisExtension */


/* Differenzdruck-Kalibriermethoden sensor_a_lower_sensor_trim, sensor_a_upper_sensor_trim und */
/* Stat. Druck-Kalibriermethoden stat_press_lower_sensor_trim, stat_press_upper_sensor_trim */
/* und Abbruch-methode leave_trim_mode definieren */

METHOD sensor_a_lower_sensor_trim
{
    HELP "|001Pressure Sensor Lower Trim- Calibrate the pressure sensor."
         "|049Untere Druckpunkt Kalibrierung- Kalibrierung des Drucksensors.";
/*  APPHELP "Note- Dangerous if performed without an accurate pressure source.";
*/

    LABEL [pressure_lower_sensor_trim];
    DEFINITION
    {
	long ids[1];
	char status[STATUS_SIZE];
	float trim_point;
	int rc;
/* loop here while getting non-zero response code */
/* could possibly use RETRY_ON_RESPONSE except that some response codes */
/* may require action to the process and we wish to reiterate the need */
/* for applied pressure */
	add_abort_method(leave_trim_mode);
	/* DO until SUCCESS */
	do {
		/* Prompt the User to Apply the lower sensor trim pressure
		   and wait for acknowledge. */
	    ACKNOWLEDGE("|001Apply low pressure|049Unt. Druck an Sensor anleg");

		/* Display PV and allow the User to press OK
		   when they feel pressure has stablilized. */
	    ids[0] = VARID(pressure.DIGITAL_VALUE);
	    acknowledge("|001Press OK when pressure is stable|049OK bettigen wenn Druck stabil %{0}", ids);

		/* First get PV to use for an editing starting point. */
	    trim_point = fvar_value(pressure.DIGITAL_VALUE);
	    rc=GET_LOCAL_VAR_VALUE("|001Enter applied pressure value|049Anliegender Druck?", trim_point);

		/* Copy the edited value into the lower_sensor_trim variable. */
	    fassign(sensor_a_lower_sensor_trim_point,trim_point);
        /* set calibration unit to pressure value unit */
        vassign(pressure_cal_units,pressure_units);
	    send(131,status); /* Send the lower_sensor_trim value. */

		/* If an error occurs display the error message and
		   wait for the User to acknowledge. */
	    if ( status[STATUS_RESPONSE_CODE] )
	        {
			display_response_status(131,status[STATUS_RESPONSE_CODE]);
	        }
	    } while ( status[STATUS_RESPONSE_CODE] );

	/* wenn Methode beendet wird, Daten ins EEPROM brennen und in */
	/* Normalmode zurckkehren                                    */
	remove_abort_method(leave_trim_mode);   /* zuerst burn_eeprom */
	add_abort_method(burn_eeprom);          /* und dann           */
	add_abort_method(return_to_normal);     /* return_to_normal   */
	/* Erfolgsmeldung ausgeben */
	DELAY(3,"|001Trim was done|049Kalibrierung ok");
	process_abort();
    }
}

METHOD sensor_a_upper_sensor_trim
{
    HELP "|001Pressure Sensor Upper Trim- Calibrate the pressure sensor."
         "|049Obere Druckpunkt Kalibrierung- Kalibrierung des Drucksensors.";
/* APPHELP "Note- Dangerous if performed without an accurate pressure source.";
*/

    LABEL [pressure_upper_sensor_trim];
    DEFINITION
    {
	long ids[1];
	char status[STATUS_SIZE];
	float trim_point;
	int rc;
/* loop here while getting non-zero response code */
/* could possibly use RETRY_ON_RESPONSE except that some response codes */
/* may require action to the process and we wish to reiterate the need */
/* for applied pressure */
	add_abort_method(leave_trim_mode);
	do {
	    /* Prompt the User to Apply the lower sensor trim pressure
	       and wait for acknowledge. */
	    ACKNOWLEDGE("|001Apply hi pressure|049Obe. Druck an Sensor anleg");

		/* Display PV and allow the User to press OK
		   when they feel pressure has stablilized. */
	    ids[0] = VARID(pressure.DIGITAL_VALUE);
	    acknowledge("|001Press OK when pressure is stable|049OK bettigen wenn Druck stabil %{0}", ids);

		/* First get PV to use for an editing starting point. */
	    trim_point = fvar_value(pressure.DIGITAL_VALUE);
	    rc=GET_LOCAL_VAR_VALUE("|001Enter applied pressure value|049Anliegender Druck?", trim_point);

		/* Copy the edited value into the upper_sensor_trim variable. */
	    fassign(sensor_a_upper_sensor_trim_point,trim_point);
        /* set calibration unit to pressure value unit */
        vassign(pressure_cal_units,pressure_units);
	    send(130,status); /* Send the lower_sensor_trim value. */

	    /* If an error occurs display the error message and
	       wait for the User to acknowledge. */
	    if ( status[STATUS_RESPONSE_CODE] )
	        {
			display_response_status(130,status[STATUS_RESPONSE_CODE]);
	        }
	   } while ( status[STATUS_RESPONSE_CODE] );

	/* wenn Methode beendet wird, Daten ins EEPROM brennen und in */
	/* Normalmode zurckkehren                                    */
	remove_abort_method(leave_trim_mode);   /* zuerst burn_eeprom */
	add_abort_method(burn_eeprom);          /* und dann           */
	add_abort_method(return_to_normal);     /* return_to_normal   */
	/* Erfolgsmeldung ausgeben */
	DELAY(3,"|001Trim was done|049Kalibrierung ok");
	process_abort();
    }
}


METHOD stat_press_lower_sensor_trim
{
    HELP "|001Pressure Sensor Lower Trim- Calibrate the static pressure sensor."
         "|049Untere Druckpunkt Kalibrierung- Kalibrierung des stat. Drucksensors.";
/*  APPHELP "Note- Dangerous if performed without an accurate pressure source.";
*/

    LABEL "|001Stat pres low snsr trim"
		  "|049Unter stat Sensabg.";

    DEFINITION
    {
	long ids[1];
	char status[STATUS_SIZE];
	float trim_point;
	int rc;

    /* bei Druckmeumformern keine stat. Druckkalibrierung zulassen und nur Meldung ausgeben */
    rc = ivar_value(module_type_code);
    if (rc >= 30)
    {
        DELAY(3,"|001No function at gauge/absolut pressure devices"
                "|049Keine Funktion bei Absolut-/Relativdruck-Meumformern");
    }

    /* sonst, nderung zulassen */
    else
    {
        /* loop here while getting non-zero response code */
        /* could possibly use RETRY_ON_RESPONSE except that some response codes */
        /* may require action to the process and we wish to reiterate the need */
        /* for applied pressure */
	    add_abort_method(leave_trim_mode);
	    /* DO until SUCCESS */
	    do {
		    /* Prompt the User to Apply the lower sensor trim pressure
		       and wait for acknowledge. */
	        ACKNOWLEDGE("|001Apply low pressure|049Unt. Druck an Sensor anleg");

		    /* Display PV and allow the User to press OK
		       when they feel pressure has stablilized. */
	        ids[0] = VARID(stat_pressure.DIGITAL_VALUE);
	        acknowledge("|001Press OK when pressure is stable|049OK bettigen wenn Druck stabil %{0}", ids);

		    /* First get PV to use for an editing starting point. */
	        trim_point = fvar_value(stat_pressure.DIGITAL_VALUE);
	        rc=GET_LOCAL_VAR_VALUE("|001Enter applied pressure value|049Anliegender Druck?", trim_point);

		    /* Copy the edited value into the lower_sensor_trim variable. */
	        fassign(stat_press_sensor_lower_sensor_trim_point,trim_point);
            /* set calibration unit to pressure value unit */
            vassign(pressure_cal_units,stat_pressure.DIGITAL_UNITS);
	        send(228,status); /* Send the lower_sensor_trim value. */

		    /* If an error occurs display the error message and
		       wait for the User to acknowledge. */
	        if ( status[STATUS_RESPONSE_CODE] )
	            {
			    display_response_status(228,status[STATUS_RESPONSE_CODE]);
	            }
	        } while ( status[STATUS_RESPONSE_CODE] );

	    /* wenn Methode beendet wird, Daten ins EEPROM brennen und in */
	    /* Normalmode zurckkehren                                    */
	    remove_abort_method(leave_trim_mode);   /* zuerst burn_eeprom */
	    add_abort_method(burn_eeprom);          /* und dann           */
	    add_abort_method(return_to_normal);     /* return_to_normal   */
	    /* Erfolgsmeldung ausgeben */
	    DELAY(3,"|001Trim was done|049Kalibrierung ok");
	    process_abort();
        }
    }
}


METHOD stat_press_upper_sensor_trim
{
    HELP "|001Pressure Sensor Upper Trim- Calibrate the static pressure sensor."
         "|049Obere Druckpunkt Kalibrierung- Kalibrierung des stat. Drucksensors.";
/*  APPHELP "Note- Dangerous if performed without an accurate pressure source.";
*/

    LABEL "|001Stat pres upp snsr trim"
		  "|049Ober stat Sensabg.";

    DEFINITION
    {
	long ids[1];
	char status[STATUS_SIZE];
	float trim_point;
	int rc;

    /* bei Druckmeumformern keine stat. Druckkalibrierung zulassen und nur Meldung ausgeben */
    rc = ivar_value(module_type_code);
    if (rc >= 30)
    {
        DELAY(3,"|001No function at gauge/absolut pressure devices"
                "|049Keine Funktion bei Absolut-/Relativdruck-Meumformern");
    }

    /* sonst, nderung zulassen */
    else
    {
        /* loop here while getting non-zero response code */
        /* could possibly use RETRY_ON_RESPONSE except that some response codes */
        /* may require action to the process and we wish to reiterate the need */
        /* for applied pressure */
	    add_abort_method(leave_trim_mode);
	    /* DO until SUCCESS */
	    do {
		    /* Prompt the User to Apply the lower sensor trim pressure
		       and wait for acknowledge. */
	        ACKNOWLEDGE("|001Apply hi pressure|049Obe. Druck an Sensor anleg");

		    /* Display PV and allow the User to press OK
		       when they feel pressure has stablilized. */
	        ids[0] = VARID(stat_pressure.DIGITAL_VALUE);
	        acknowledge("|001Press OK when pressure is stable|049OK bettigen wenn Druck stabil %{0}", ids);

		    /* First get PV to use for an editing starting point. */
	        trim_point = fvar_value(stat_pressure.DIGITAL_VALUE);
	        rc=GET_LOCAL_VAR_VALUE("|001Enter applied pressure value|049Anliegender Druck?", trim_point);

		    /* Copy the edited value into the lower_sensor_trim variable. */
	        fassign(stat_press_sensor_upper_sensor_trim_point,trim_point);
            /* set calibration unit to pressure value unit */
            vassign(pressure_cal_units,stat_pressure.DIGITAL_UNITS);
	        send(227,status); /* Send the lower_sensor_trim value. */

		    /* If an error occurs display the error message and
		       wait for the User to acknowledge. */
	        if ( status[STATUS_RESPONSE_CODE] )
	            {
			    display_response_status(227,status[STATUS_RESPONSE_CODE]);
	            }
	        }
        while ( status[STATUS_RESPONSE_CODE] );

	    /* wenn Methode beendet wird, Daten ins EEPROM brennen und in */
	    /* Normalmode zurckkehren                                    */
	    remove_abort_method(leave_trim_mode);   /* zuerst burn_eeprom */
	    add_abort_method(burn_eeprom);          /* und dann           */
	    add_abort_method(return_to_normal);     /* return_to_normal   */
	    /* Erfolgsmeldung ausgeben */
	    DELAY(3,"|001Trim was done|049Kalibrierung ok");
	    process_abort();
        }
    }
}


METHOD leave_trim_mode
{
    HELP "Exit Trim Mode- Notifies the User that the trim is finished.";

    LABEL [exit_trim_mode];
    DEFINITION
    {
		ACKNOWLEDGE("|001Trim was not done|049Kalibrierung fehlgeschlagen");
    }
}


/* Methoden self_test, stuck_in_self_test und self_test_end definieren (Selbsttest) */

METHOD self_test
{
    LABEL  [selftest];
    HELP "|001Performs self test on the 2000T. Reports any errors."
	     "|049Fhrt Selbsttest beim 2000T durch. Gibt alle dabei auftretenden Fehler aus.";
    DEFINITION
    {
        int number_of_tries;
        int control;
        char status[STATUS_SIZE];
        char xmtr_status[MAX_XMTR_STATUS_LEN];
        char disp_string1[60];
        int slen1;
        long ids[2];
        slen1 = 60;
        number_of_tries = 0;
        /* alle nachfolgenden Response-Codes und gesetzten Device-Status-Bits */
        /* sollen nicht zum Abbruch der Methode fhren.                       */
        IGNORE_ALL_RESPONSE_CODES();
        IGNORE_ALL_DEVICE_STATUS();
        XMTR_IGNORE_ALL_RESPONSE_CODES();
        XMTR_IGNORE_ALL_DEVICE_STATUS();
        /* tue ... */
        do
        {
	        /* Selbsttest-Kommando #41 zum Messumformer senden */
	        send(41, status);
        }
        /* solange Messumformer noch beschftigt ist */
        while (status[STATUS_RESPONSE_CODE] == DEVICE_BUSY);
        /* wenn Messumformerzugriff beschrnkt, ... */
        if (status[STATUS_RESPONSE_CODE] == ACCESS_RESTRICTED)
        {
	        /* Response-Code ausgeben */
	        display_response_status(41,status[STATUS_RESPONSE_CODE]);
	        /* Abbruchmeldung ausgeben */
	        get_dictionary_string(abort_last_error, disp_string1, slen1);
	        DELAY(4,disp_string1);
        }
        /* sonst ... */
        else
        {
	        /* tue ... */
	        do
	        {
	            /* Kommando #48 zum Messumformer schicken und Statusbytes holen    */
	            get_more_status(status,xmtr_status);
	            number_of_tries = number_of_tries + 1;
	        }
	        /* solange Messumformer noch beschftigt ist oder maximale Selbsttest- */
	        /* zeit noch nicht abgelaufen ist.                                    */
	        while ((status[STATUS_RESPONSE_CODE] == DEVICE_BUSY) &&
	               (number_of_tries < MAXIMUM_SELFTEST_TIME));
	        /* Methoden-Ablaufkontrolle setzen */
	        control = 0;
	        /* wenn max. Selbsttestzeit abgelaufen, Fehlermeldung ausgeben. */
	        if ( status[STATUS_RESPONSE_CODE] == DEVICE_BUSY)
	        {
	            /* Methode beenden */
			    add_abort_method(stuck_in_self_test);
	            process_abort();
	        }
	        /* sonst wenn Selbsttest Fehler entdeckt hat, diese Fehler ausgeben */
	        else
	        {
	            if ( xmtr_status[14] & HARDWARE_FAILURE_ELECTRONIC )
	            {
		            ACKNOWLEDGE("|001Hardware failure of the electronic"
                                "|049Elektronikfehler Hardware");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[14] & MEMORY_ERROR )
	            {
		            ACKNOWLEDGE("|001Memory error"
                                "|049Memory Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[14] & FAIL_MEASUREMENT )
	            {
		            ACKNOWLEDGE("|001Failure in measurement"
                                "|049Fehler A/D Wandler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[15] & CONFIG_NOT_VALID )
	            {
		            ACKNOWLEDGE("|001Configuration not valid"
                                "|049Konfiguration ungltig");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & ELECTR_EEPROM_ERROR )
	            {
		            ACKNOWLEDGE("|001Comm Error Electr-EEPROM"
                                "|049Kommunikationsfehler Elektr-EEPROM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & SENSOR_EEPROM_ERROR )
	            {
		            ACKNOWLEDGE("|001Comm Error Sensor-EEPROM"
                                "|049Kommunikationsfehler Sensor-EEPROM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & ELECTR_MAX_WRITE_CYCLES )
	            {
		            ACKNOWLEDGE("|001max Write-Cycles Electr-EEPROM"
                                "|049max Schreibzyklen Elektr-EEPROM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & SENSOR_MAX_WRITE_CYCLES )
	            {
		            ACKNOWLEDGE("|001max Write-Cycles Sensor-EEPROM"
                                "|049max Schreibzyklen Sensor-EEPROM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & ELECTR_DATA_ERROR )
	            {
		            ACKNOWLEDGE("|001Electronic Data Error"
                                "|049Elektronik-Daten Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & SENSOR_DATA_ERROR )
	            {
		            ACKNOWLEDGE("|001Sensor Data Error"
                                "|049Sensor-Daten Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & CONFIG_DATA_ERROR )
	            {
		            ACKNOWLEDGE("|001User Data Error"
                                "|049Benutzer-Daten Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[18] & FACTORY_DATA_ERROR )
	            {
		            ACKNOWLEDGE("|001Factory Reset Data Error"
                                "|049Werkseinstelldaten Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[19] & EEPROM_DATA_SAVE)
	            {
		            ACKNOWLEDGE("|001Saving EEPROM Data Error"
                                "|049Werkseinstelldaten Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[19] & DEVICE_IS_BUSY )
	            {
		            ACKNOWLEDGE("|001Device is busy"
                                "|049Gert ist beschftigt");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[19] & CYCLIC_DATA_LEN_ERROR )
	            {
		            ACKNOWLEDGE("|001Wrong length of EEPROM cycl data"
                                "|049Lnge des zykl. Datensatzes falsch");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[19] & CYCLIC_DATA_NOT_READABLE )
	            {
		            ACKNOWLEDGE("|001EEPROM cycl object not readable"
                                "|049Objekt zykl. Datensatz unlesbar");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[19] & CYCLIC_DATA_NOT_WRITEABLE )
	            {
		            ACKNOWLEDGE("|001EEPROM cycl object not writable"
                                "|049Objekt zykl. Datensatz nicht schreibbar");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[20] & ALARM_ROM )
	            {
		            ACKNOWLEDGE("|001ROM error"
                                "|049ROM Fehler");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[20] & ALARM_INT_RAM )
	            {
		            ACKNOWLEDGE("|001Error int RAM"
                                "|049Fehler int. RAM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[20] & ALARM_EXT_RAM )
	            {
		            ACKNOWLEDGE("|001Error ext RAM"
                                "|049Fehler ext RAM");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[21] & STATUS_CURR_MIN )
	            {
		            ACKNOWLEDGE("|001Current reached lower limit"
                                "|049untere Strombegrenzung");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	            if ( xmtr_status[21] & STATUS_CURR_MAX )
	            {
		            ACKNOWLEDGE("|001Current reached upper limit"
                                "|049obere Strombegrenzung");
		            /* Ende der Methode vorbereiten */
		            control = 1;
	            }
	        }
	        /* wenn alles in Ordnung OK-Meldung ausgeben und Methode beenden */
	        if ( control == 0 )
	        {
	            add_abort_method(self_test_end);
	            process_abort();
	        }
        }
    }
}


METHOD stuck_in_self_test
{
    LABEL  "|001Stuck in self test"
	       "|049Fehler beim Selbsttest";
    DEFINITION
    {
        ACKNOWLEDGE("|001Device maybe stuck in selftest."
	                "|049Selbsttestfehler des Gertes");
    }
}


METHOD self_test_end
{
    LABEL  "|001Self test OK"
	       "|049Selbsttest OK";
    DEFINITION
    {
        ACKNOWLEDGE("|001Self test OK"
	                "|049Selbsttest OK");
    }
}



/* Methoden master_reset und master_reset_end definieren (Neustart des Messumformers) */

METHOD master_reset
{
    LABEL  "|001Master reset"
	       "|049Neustart Meumf.";
    HELP "|001Resets the 2000T electronic"
	     "|049Setzt die 2000T-Elektronik zurck";
    DEFINITION
    {
        int number_of_tries;
        int control;
        char status[STATUS_SIZE];
        char xmtr_status[MAX_XMTR_STATUS_LEN];
        char disp_string1[60];
        int slen1;
        long ids[2];
        slen1 = 60;
        number_of_tries = 0;
        /* alle nachfolgenden Response-Codes, gesetzte Device-Status-Bits und  */
        /* Kommunikationsfehler sollen nicht zum Abbruch der Methode fhren.   */
        IGNORE_ALL_RESPONSE_CODES();
        IGNORE_ALL_DEVICE_STATUS();
        XMTR_IGNORE_ALL_RESPONSE_CODES();
        XMTR_IGNORE_ALL_DEVICE_STATUS();
        IGNORE_COMM_ERROR();
        IGNORE_COMM_STATUS(127);
        XMTR_IGNORE_COMM_ERROR();
        XMTR_IGNORE_COMM_STATUS(127);
        /* Wenn whrend des Master-Reset keine Antwort vom Messumformer auf ein */
        /* Kommando kommt, dann dieses maximal 10-mal wiederholen.             */
        RETRY_ON_NO_DEVICE();
        XMTR_RETRY_ON_NO_DEVICE();
        SET_NUMBER_OF_RETRIES(10);
        /* tue ... */
        do
        {
	        /* Master-Reset-Kommando zum Messumformer senden */
	        send(42, status);
        }
        /* solange Messumformer noch beschftigt */
        while (status[STATUS_RESPONSE_CODE] == DEVICE_BUSY);
        /* Anzahl der Kommandowiederholungen = 0 */
        SET_NUMBER_OF_RETRIES(0);
        /* wenn Messumformer in Schreibschutzmode ... */
        if (status[STATUS_RESPONSE_CODE] == WRITE_PROTECTED)
        {
	        /* Response-Code ausgeben */
	        display_response_status(42,status[STATUS_RESPONSE_CODE]);
	        /* Abbruchmeldung ausgeben */
	        get_dictionary_string(abort_last_error, disp_string1, slen1);
	        DELAY(4,disp_string1);
        }
        /* sonst ... */
        else
        {
	        DELAY(2, "|001Please wait ..."
	          "|049Bitte warten ...");
	        /* tue ... */
	        do
	        {
	            /* Selbsttest-Kommando #41 zum Messumformer senden */
	            send(41, status);
	        }
	        /* solange Messumformer noch beschftigt ist */
	        while (status[STATUS_RESPONSE_CODE] == DEVICE_BUSY);
	        /* wenn Messumformerzugriff beschrnkt, ... */
	        if (status[STATUS_RESPONSE_CODE] == ACCESS_RESTRICTED)
	        {
	            /* Response-Code ausgeben */
	            display_response_status(41,status[STATUS_RESPONSE_CODE]);
	            /* Abbruchmeldung ausgeben */
	            get_dictionary_string(abort_last_error, disp_string1, slen1);
	            DELAY(4,disp_string1);
	        }
	        /* sonst ... */
	        else
	        {
	            /* tue ... */
	            do
	            {
		            /* Kommando #48 zum Messumformer schicken und Statusbytes holen    */
		            get_more_status(status,xmtr_status);
		            number_of_tries = number_of_tries + 1;
	            }
	            /* solange Messumformer noch beschftigt ist oder maximale Selbsttest- */
	            /* zeit noch nicht abgelaufen ist.                                    */
	            while ((status[STATUS_RESPONSE_CODE] == DEVICE_BUSY) &&
		               (number_of_tries < MAXIMUM_SELFTEST_TIME));
	            /* Methoden-Ablaufkontrolle setzen */
	            control = 0;
	            /* wenn max. Selbsttestzeit abgelaufen, Fehlermeldung ausgeben. */
	            if ( status[STATUS_RESPONSE_CODE] == DEVICE_BUSY)
	            {
		            /* Methode beenden */
			        add_abort_method(stuck_in_self_test);
		            process_abort();
	            }
	            /* sonst wenn Selbsttest Fehler entdeckt hat, diese Fehler ausgeben */
	            else
	            {
	                if ( xmtr_status[14] & HARDWARE_FAILURE_ELECTRONIC )
	                {
		                ACKNOWLEDGE("|001Hardware failure of the electronic"
                                    "|049Elektronikfehler Hardware");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[14] & MEMORY_ERROR )
	                {
		                ACKNOWLEDGE("|001Memory error"
                                    "|049Memory Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[14] & FAIL_MEASUREMENT )
	                {
		                ACKNOWLEDGE("|001Failure in measurement"
                                    "|049Fehler A/D Wandler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[15] & CONFIG_NOT_VALID )
	                {
		                ACKNOWLEDGE("|001Configuration not valid"
                                    "|049Konfiguration ungltig");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & ELECTR_EEPROM_ERROR )
	                {
		                ACKNOWLEDGE("|001Comm Error Electr-EEPROM"
                                    "|049Kommunikationsfehler Elektr-EEPROM");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & SENSOR_EEPROM_ERROR )
	                {
		                ACKNOWLEDGE("|001Comm Error Sensor-EEPROM"
                                    "|049Kommunikationsfehler Sensor-EEPROM");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & ELECTR_MAX_WRITE_CYCLES )
	                {
		                ACKNOWLEDGE("|001max Write-Cycles Electr-EEPROM"
                                    "|049max Schreibzyklen Elektr-EEPROM");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & SENSOR_MAX_WRITE_CYCLES )
	                {
                        ACKNOWLEDGE("|001max Write-Cycles Sensor-EEPROM"
                                    "|049max Schreibzyklen Sensor-EEPROM");
	                    /* Ende der Methode vorbereiten */
	                    control = 1;
	                }
	                if ( xmtr_status[18] & ELECTR_DATA_ERROR )
	                {
		                ACKNOWLEDGE("|001Electronic Data Error"
                                    "|049Elektronik-Daten Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & SENSOR_DATA_ERROR )
	                {
		                ACKNOWLEDGE("|001Sensor Data Error"
                                    "|049Sensor-Daten Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & CONFIG_DATA_ERROR )
	                {
		                ACKNOWLEDGE("|001User Data Error"
                                    "|049Benutzer-Daten Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[18] & FACTORY_DATA_ERROR )
	                {
		                ACKNOWLEDGE("|001Factory Reset Data Error"
                                    "|049Werkseinstelldaten Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[19] & EEPROM_DATA_SAVE)
	                {
		                ACKNOWLEDGE("|001Saving EEPROM Data Error"
                                    "|049Werkseinstelldaten Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[19] & DEVICE_IS_BUSY )
	                {
		                ACKNOWLEDGE("|001Device is busy"
                                    "|049Gert ist beschftigt");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[19] & CYCLIC_DATA_LEN_ERROR )
	                {
		                ACKNOWLEDGE("|001Wrong length of EEPROM cycl data"
                                    "|049Lnge des zykl. Datensatzes falsch");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[19] & CYCLIC_DATA_NOT_READABLE )
	                {
		                ACKNOWLEDGE("|001EEPROM cycl object not readable"
                                    "|049Objekt zykl. Datensatz unlesbar");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[19] & CYCLIC_DATA_NOT_WRITEABLE )
	                {
		                ACKNOWLEDGE("|001EEPROM cycl object not writable"
                                    "|049Objekt zykl. Datensatz nicht schreibbar");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[20] & ALARM_ROM )
	                {
		                ACKNOWLEDGE("|001ROM error"
                                    "|049ROM Fehler");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[20] & ALARM_INT_RAM )
	                {
		                ACKNOWLEDGE("|001Error int RAM"
                                    "|049Fehler int. RAM");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[20] & ALARM_EXT_RAM )
	                {
		                ACKNOWLEDGE("|001Error ext RAM"
                                    "|049Fehler ext RAM");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[21] & STATUS_CURR_MIN )
	                {
		                ACKNOWLEDGE("|001Current reached lower limit"
                                    "|049untere Strombegrenzung");
		                /* Ende der Methode vorbereiten */
		                control = 1;
	                }
	                if ( xmtr_status[21] & STATUS_CURR_MAX )
	                {
		                ACKNOWLEDGE("|001Current reached upper limit"
                                    "|049obere Strombegrenzung");
		                /* Ende der Methode vorbereiten */
		                control = 1;
		            }
	            }
	            /* wenn alles in Ordnung OK-Meldung ausgeben und Methode beenden */
	            if ( control == 0 )
	            {
			        add_abort_method(master_reset_end);
		            process_abort();
	            }
	        }
        }
    }
}


METHOD master_reset_end
{
    LABEL  "|001Master reset OK"
	       "|049Neustart Meumf. OK";
    DEFINITION
    {
        ACKNOWLEDGE("|001Master reset OK"
	                "|049Neustart OK");
    }
}



/* Methode, um fr das Schreiben der Temperatureinheit, bentigte Variablen auszulesen. */
/* Die Variablenwerte werden fr das Schreibkommando bentigt. */

METHOD temp_unit_action
{
	LABEL "|001temp unit action"
	      "|049temp unit action" ;

	DEFINITION
	{
		char status[STATUS_SIZE];

		/* alle nachfolgenden Response-Codes und gesetzten Device-Status-Bits */
		/* sollen nicht zum Abbruch der Methode fhren.                       */
		IGNORE_ALL_RESPONSE_CODES();
		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_RESPONSE_CODES();
		XMTR_IGNORE_ALL_DEVICE_STATUS();

		/* tue ... */
		do
		{
        	/* Kommando #222 zum Messumformer senden */
		    send(222, status);
		}
		/* solange Messumformer noch beschftigt ist */
		while (status[STATUS_RESPONSE_CODE] == DEVICE_BUSY);
	}
}


/* Methoden, um fr das Schreiben der Druck-Einheiten mit K#35 bzw. #165, die im Kommando enthaltenen */
/* Mebereichsgrenzen auf die neue Dimension umzurechnen. Sie werden als Pre/Post Edit Actions */
/* bei pressure_unit bzw. static_pressure_units eingetragen */


VARIABLE  old_pressure_unit
{
    LABEL  "old unit";
    CLASS  LOCAL;
    HANDLING READ & WRITE;
    TYPE   INTEGER;
}


/* Methoden fr den Differenzdruck */

METHOD store_old_press_unit
{
    LABEL "Str. old unit";

    DEFINITION
    {
        int unit;

        /* alten Dimensionswert laden */
        unit = ivar_value(pressure_units);
        iassign(old_pressure_unit, unit);

	    /* Wert speichern */
	    save_values();
    }
}


METHOD calc_new_pressure_range_values
{
	LABEL "Pres. units";

	DEFINITION
	{
        int     old_unit,new_unit;
		float   loc_var;

        /* hole alten Dimensionswert */
        old_unit = ivar_value(old_pressure_unit);

        /* hole neuen Dimensionswert */
        new_unit = ivar_value(pressure_units);

        /* hole alten oberen Mebereichsgrenzwert */
        loc_var = fvar_value(pressure_upper_range_value);

        /* umrechnung von wert in alter Dimension nach mbar */
        switch (old_unit)
            {
            case 1:     /* INCHES_H2O */
                loc_var = loc_var * 2.49089;
                break;

            case 2:     /* INCHES_HG */
                loc_var = loc_var * 33.8639;
                break;

            case 3:     /* FEET_H2O */
                loc_var = loc_var * 29.8907;
                break;

            case 4:     /* MILLIMETER_H2O */
                loc_var = loc_var * 0.0980665;
                break;

            case 5:     /* MILLIMETER_HG */
                loc_var = loc_var * 1.33322;
                break;

            case 6:     /* PSI */
                loc_var = loc_var * 68.9476;
                break;

            case 7:     /* BAR */
                loc_var = loc_var * 1E+03;
                break;

            case 8:     /* MILLIBAR */
                loc_var = loc_var;
                break;

            case 9:     /* GRAM_CENTIMETER2 */
                loc_var = loc_var * 0.980665;
                break;

            case 10:    /* KILOGRAM_CENTIMETER2 */
                loc_var = loc_var * 980.665;
                break;

            case 11:    /* PASCAL */
                loc_var = loc_var * 1E-02;
                break;

            case 12:    /* KILOPASCAL */
                loc_var = loc_var * 1E+01;
                break;

            case 13:    /* TORR */
                loc_var = loc_var * 1.33322;
                break;

            case 14:    /* ATMOSPHERE */
                loc_var = loc_var * 1013.25;
                break;

            case 237:   /* MEGAPASCAL */
                loc_var = loc_var * 1E+04;
                break;

            default:
                loc_var = loc_var;
                break;
            }

        /* umrechnung von wert in mbar nach neuer Dimension */
        switch (new_unit)
            {
            case 1:     /* INCHES_H2O */
                loc_var = loc_var * 0.401463;
                break;

            case 2:     /* INCHES_HG */
                loc_var = loc_var * 0.02953;
                break;

            case 3:     /* FEET_H2O */
                loc_var = loc_var * 0.0334553;
                break;

            case 4:     /* MILLIMETER_H2O */
                loc_var = loc_var * 10.1972;
                break;

            case 5:     /* MILLIMETER_HG */
                loc_var = loc_var * 0.750062;
                break;

            case 6:     /* PSI */
                loc_var = loc_var * 0.0145038;
                break;

            case 7:     /* BAR */
                loc_var = loc_var * 0.001;
                break;

            case 8:     /* MILLIBAR */
                loc_var = loc_var;
                break;

            case 9:     /* GRAM_CENTIMETER2 */
                loc_var = loc_var * 1.01972;
                break;

            case 10:    /* KILOGRAM_CENTIMETER2 */
                loc_var = loc_var * 0.00101972;
                break;

            case 11:    /* PASCAL */
                loc_var = loc_var * 100;
                break;

            case 12:    /* KILOPASCAL */
                loc_var = loc_var * 0.1;
                break;

            case 13:    /* TORR */
                loc_var = loc_var * 0.750062;
                break;

            case 14:    /* ATMOSPHERE */
                loc_var = loc_var * 0.000986923;
                break;

            case 237:   /* MEGAPASCAL */
                loc_var = loc_var * 1E-04;
                break;

            default:
                loc_var = loc_var;
                break;
            }

        /* umdimensionierten Wert zuweisen */
        fassign (pressure_upper_range_value, loc_var);

	    /* hole alten unteren Mebereichsgrenzwert */
	    loc_var = fvar_value(pressure_lower_range_value);
	    /* umrechnung von wert in alter Dimension nach mbar */
	    switch (old_unit)
	        {
	        case 1:     /* INCHES_H2O */
	            loc_var = loc_var * 2.49089;
	            break;

	        case 2:     /* INCHES_HG */
	            loc_var = loc_var * 33.8639;
	            break;

	        case 3:     /* FEET_H2O */
	            loc_var = loc_var * 29.8907;
	            break;

	        case 4:     /* MILLIMETER_H2O */
	            loc_var = loc_var * 0.0980665;
	            break;

	        case 5:     /* MILLIMETER_HG */
	            loc_var = loc_var * 1.33322;
	            break;

	        case 6:     /* PSI */
	            loc_var = loc_var * 68.9476;
	            break;

	        case 7:     /* BAR */
	            loc_var = loc_var * 1E+03;
	            break;

	        case 8:     /* MILLIBAR */
	            loc_var = loc_var;
	            break;

	        case 9:     /* GRAM_CENTIMETER2 */
	            loc_var = loc_var * 0.980665;
	            break;

	        case 10:    /* KILOGRAM_CENTIMETER2 */
	            loc_var = loc_var * 980.665;
	            break;

	        case 11:    /* PASCAL */
	            loc_var = loc_var * 1E-02;
	            break;

	        case 12:    /* KILOPASCAL */
	            loc_var = loc_var * 1E+01;
	            break;

	        case 13:    /* TORR */
	            loc_var = loc_var * 1.33322;
	            break;

	        case 14:    /* ATMOSPHERE */
	            loc_var = loc_var * 1013.25;
	            break;

	        case 237:   /* MEGAPASCAL */
	            loc_var = loc_var * 1E+04;
	            break;

	        default:
	            loc_var = loc_var;
	            break;
	        }

	    /* umrechnung von wert in mbar nach neuer Dimension */
	    switch (new_unit)
	        {
	        case 1:     /* INCHES_H2O */
	            loc_var = loc_var * 0.401463;
	            break;

	        case 2:     /* INCHES_HG */
	            loc_var = loc_var * 0.02953;
	            break;

	        case 3:     /* FEET_H2O */
	            loc_var = loc_var * 0.0334553;
	            break;

	        case 4:     /* MILLIMETER_H2O */
	            loc_var = loc_var * 10.1972;
	            break;

	        case 5:     /* MILLIMETER_HG */
	            loc_var = loc_var * 0.750062;
	            break;

	        case 6:     /* PSI */
	            loc_var = loc_var * 0.0145038;
	            break;

	        case 7:     /* BAR */
	            loc_var = loc_var * 0.001;
	            break;

	        case 8:     /* MILLIBAR */
	            loc_var = loc_var;
	            break;

	        case 9:     /* GRAM_CENTIMETER2 */
	            loc_var = loc_var * 1.01972;
	            break;

	        case 10:    /* KILOGRAM_CENTIMETER2 */
	            loc_var = loc_var * 0.00101972;
	            break;

	        case 11:    /* PASCAL */
	            loc_var = loc_var * 100;
	            break;

	        case 12:    /* KILOPASCAL */
	            loc_var = loc_var * 0.1;
	            break;

	        case 13:    /* TORR */
	            loc_var = loc_var * 0.750062;
	            break;

	        case 14:    /* ATMOSPHERE */
	            loc_var = loc_var * 0.000986923;
	            break;

	        case 237:   /* MEGAPASCAL */
	            loc_var = loc_var * 1E-04;
	            break;

	        default:
	            loc_var = loc_var;
	            break;
	        }

	    /* umdimensionierten Wert zuweisen */
	    fassign (pressure_lower_range_value, loc_var);

	    /* Werte speichern */
	    save_values();

	    /* Warnung ausgeben */
	    ACKNOWLEDGE("|001Variables with this unit maintain their old value until a new unit has been "
	                "sent to the device."
	                "|049Variablen mit dieser Dimension behalten ihren alten Wert bis die neue "
	                "Dimension zum Gert gesendet wurde.");
	}
}


/* Methoden fr den stat. Druck */

METHOD store_old_stat_press_unit
{
    LABEL "Str. old unit";

    DEFINITION
    {
        int unit;

        /* alten Dimensionswert laden */
        unit = ivar_value(static_pressure_units);
        iassign(old_pressure_unit, unit);

	    /* Wert speichern */
	    save_values();
    }
}


METHOD calc_new_stat_pressure_range_values
{
	LABEL "Stat pres unit";

	DEFINITION
	{
        int     old_unit,new_unit;
		float   loc_var;

        /* hole alten Dimensionswert */
        old_unit = ivar_value(old_pressure_unit);

        /* hole neuen Dimensionswert */
        new_unit = ivar_value(static_pressure_units);

        /* hole alten oberen Mebereichsgrenzwert */
        loc_var = fvar_value(static_pressure_upper_range_value);

        /* umrechnung von wert in alter Dimension nach mbar */
        switch (old_unit)
            {
            case 1:     /* INCHES_H2O */
                loc_var = loc_var * 2.49089;
                break;

            case 2:     /* INCHES_HG */
                loc_var = loc_var * 33.8639;
                break;

            case 3:     /* FEET_H2O */
                loc_var = loc_var * 29.8907;
                break;

            case 4:     /* MILLIMETER_H2O */
                loc_var = loc_var * 0.0980665;
                break;

            case 5:     /* MILLIMETER_HG */
                loc_var = loc_var * 1.33322;
                break;

            case 6:     /* PSI */
                loc_var = loc_var * 68.9476;
                break;

            case 7:     /* BAR */
                loc_var = loc_var * 1E+03;
                break;

            case 8:     /* MILLIBAR */
                loc_var = loc_var;
                break;

            case 9:     /* GRAM_CENTIMETER2 */
                loc_var = loc_var * 0.980665;
                break;

            case 10:    /* KILOGRAM_CENTIMETER2 */
                loc_var = loc_var * 980.665;
                break;

            case 11:    /* PASCAL */
                loc_var = loc_var * 1E-02;
                break;

            case 12:    /* KILOPASCAL */
                loc_var = loc_var * 1E+01;
                break;

            case 13:    /* TORR */
                loc_var = loc_var * 1.33322;
                break;

            case 14:    /* ATMOSPHERE */
                loc_var = loc_var * 1013.25;
                break;

            case 237:   /* MEGAPASCAL */
                loc_var = loc_var * 1E+04;
                break;

            default:
                loc_var = loc_var;
                break;
            }

        /* umrechnung von wert in mbar nach neuer Dimension */
        switch (new_unit)
            {
            case 1:     /* INCHES_H2O */
                loc_var = loc_var * 0.401463;
                break;

            case 2:     /* INCHES_HG */
                loc_var = loc_var * 0.02953;
                break;

            case 3:     /* FEET_H2O */
                loc_var = loc_var * 0.0334553;
                break;

            case 4:     /* MILLIMETER_H2O */
                loc_var = loc_var * 10.1972;
                break;

            case 5:     /* MILLIMETER_HG */
                loc_var = loc_var * 0.750062;
                break;

            case 6:     /* PSI */
                loc_var = loc_var * 0.0145038;
                break;

            case 7:     /* BAR */
                loc_var = loc_var * 0.001;
                break;

            case 8:     /* MILLIBAR */
                loc_var = loc_var;
                break;

            case 9:     /* GRAM_CENTIMETER2 */
                loc_var = loc_var * 1.01972;
                break;

            case 10:    /* KILOGRAM_CENTIMETER2 */
                loc_var = loc_var * 0.00101972;
                break;

            case 11:    /* PASCAL */
                loc_var = loc_var * 100;
                break;

            case 12:    /* KILOPASCAL */
                loc_var = loc_var * 0.1;
                break;

            case 13:    /* TORR */
                loc_var = loc_var * 0.750062;
                break;

            case 14:    /* ATMOSPHERE */
                loc_var = loc_var * 0.000986923;
                break;

            case 237:   /* MEGAPASCAL */
                loc_var = loc_var * 1E-04;
                break;

            default:
                loc_var = loc_var;
                break;
            }

        /* umdimensionierten Wert zuweisen */
        fassign (static_pressure_upper_range_value, loc_var);

	    /* hole alten unteren Mebereichsgrenzwert */
	    loc_var = fvar_value(static_pressure_lower_range_value);
	    /* umrechnung von wert in alter Dimension nach mbar */
	    switch (old_unit)
	        {
	        case 1:     /* INCHES_H2O */
	            loc_var = loc_var * 2.49089;
	            break;

	        case 2:     /* INCHES_HG */
	            loc_var = loc_var * 33.8639;
	            break;

	        case 3:     /* FEET_H2O */
	            loc_var = loc_var * 29.8907;
	            break;

	        case 4:     /* MILLIMETER_H2O */
	            loc_var = loc_var * 0.0980665;
	            break;

	        case 5:     /* MILLIMETER_HG */
	            loc_var = loc_var * 1.33322;
	            break;

	        case 6:     /* PSI */
	            loc_var = loc_var * 68.9476;
	            break;

	        case 7:     /* BAR */
	            loc_var = loc_var * 1E+03;
	            break;

	        case 8:     /* MILLIBAR */
	            loc_var = loc_var;
	            break;

	        case 9:     /* GRAM_CENTIMETER2 */
	            loc_var = loc_var * 0.980665;
	            break;

	        case 10:    /* KILOGRAM_CENTIMETER2 */
	            loc_var = loc_var * 980.665;
	            break;

	        case 11:    /* PASCAL */
	            loc_var = loc_var * 1E-02;
	            break;

	        case 12:    /* KILOPASCAL */
	            loc_var = loc_var * 1E+01;
	            break;

	        case 13:    /* TORR */
	            loc_var = loc_var * 1.33322;
	            break;

	        case 14:    /* ATMOSPHERE */
	            loc_var = loc_var * 1013.25;
	            break;

	        case 237:   /* MEGAPASCAL */
	            loc_var = loc_var * 1E+04;
	            break;

	        default:
	            loc_var = loc_var;
	            break;
	        }

	    /* umrechnung von wert in mbar nach neuer Dimension */
	    switch (new_unit)
	        {
	        case 1:     /* INCHES_H2O */
	            loc_var = loc_var * 0.401463;
	            break;

	        case 2:     /* INCHES_HG */
	            loc_var = loc_var * 0.02953;
	            break;

	        case 3:     /* FEET_H2O */
	            loc_var = loc_var * 0.0334553;
	            break;

	        case 4:     /* MILLIMETER_H2O */
	            loc_var = loc_var * 10.1972;
	            break;

	        case 5:     /* MILLIMETER_HG */
	            loc_var = loc_var * 0.750062;
	            break;

	        case 6:     /* PSI */
	            loc_var = loc_var * 0.0145038;
	            break;

	        case 7:     /* BAR */
	            loc_var = loc_var * 0.001;
	            break;

	        case 8:     /* MILLIBAR */
	            loc_var = loc_var;
	            break;

	        case 9:     /* GRAM_CENTIMETER2 */
	            loc_var = loc_var * 1.01972;
	            break;

	        case 10:    /* KILOGRAM_CENTIMETER2 */
	            loc_var = loc_var * 0.00101972;
	            break;

	        case 11:    /* PASCAL */
	            loc_var = loc_var * 100;
	            break;

	        case 12:    /* KILOPASCAL */
	            loc_var = loc_var * 0.1;
	            break;

	        case 13:    /* TORR */
	            loc_var = loc_var * 0.750062;
	            break;

	        case 14:    /* ATMOSPHERE */
	            loc_var = loc_var * 0.000986923;
	            break;

	        case 237:   /* MEGAPASCAL */
	            loc_var = loc_var * 1E-04;
	            break;

	        default:
	            loc_var = loc_var;
	            break;
	        }

	    /* umdimensionierten Wert zuweisen */
	    fassign (static_pressure_lower_range_value, loc_var);

	    /* Werte speichern */
	    save_values();

	    /* Warnung ausgeben */
	    ACKNOWLEDGE("|001Variables with this unit maintain their old value until a new unit has been "
	                "sent to the device."
	                "|049Variablen mit dieser Dimension behalten ihren alten Wert bis die neue "
	                "Dimension zum Gert gesendet wurde.");
	}
}



/* Methode, um die Konfidaten auf Werkseinstellung zurckzusetzen */
METHOD reset_factory_data
{
	LABEL "|001Factory reset|049Rcks. Werkseinst.";

	HELP "|001ATTENTION! This will reset all user configured data to factory default values!"
	     "|049ACHTUNG! Es werden alle vom Benutzer konfigurierten Daten auf den Auslieferungszustand"
	     " zurckgesetzt!";

	DEFINITION
	{
		char status[3];

		IGNORE_ALL_RESPONSE_CODES();
		XMTR_IGNORE_ALL_RESPONSE_CODES();
		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();

		assign_int(eeprom_select,1);
		ACKNOWLEDGE("|001ATTENTION! This will reset all user configured data to factory default values!"
	                "|049ACHTUNG! Es werden alle vom Benutzer konfigurierten Daten auf den Auslieferungszustand"
	                " zurckgesetzt!");
		send(39,status);
		if ( status[STATUS_RESPONSE_CODE] )
	    {
			display_response_status(39,status[STATUS_RESPONSE_CODE]);
			ACKNOWLEDGE("|001Reset failed|049Rcksetzen fehlgeschlagen");
	    }
	}
}
